<?php
header('Content-type: application/json');
require_once "funcions.php";

if( isset($_POST['id_usuario']) )
{
    $id_usuario = trim($_POST['id_usuario']);
    $dbMySQL = connexioMySql();
    $stmt = $dbMySQL->prepare("SELECT * FROM biblioteca, llibres, llibre_autor, autors, llibre_genere, generes
                              WHERE biblioteca.id_llibre = llibres.id_llibre and
                                    biblioteca.id_usuari=:id_usuario and
                                    llibre_autor.id_llibre=llibres.id_llibre AND
                                    llibre_autor.id_autor = autors.id_autor and
                                    llibre_genere.id_llibre=llibres.id_llibre AND
                                    llibre_genere.id_genere = generes.id_genere
                              order by titol,autor");
    $stmt->bindParam(":id_usuario", $id_usuario, PDO::PARAM_INT);
    $stmt->execute();
    $arr='[';
    while($row = $stmt->fetch(PDO::FETCH_ASSOC))
    {
        $titulo=$row['titol'];
        $id_libro=$row['id_llibre'];
        $isbn=$row['ISBN'];
        $autor=$row['autor'];
        $genero=utf8_encode($row['genere']);
        $extension = $row['extensio_portada'];

        $ruta="../portadas/".$id_libro.".".$extension;
        if (file_exists($ruta)) {
            $data = file_get_contents($ruta);
            $portada = base64_encode($data);
        }
        else{
            $portada = "-";
        }

        $arr.='{
                    "titulo":"'.$titulo.'",
                    "id_libro":'.$id_libro.',
                    "isbn":"'.$isbn.'",
                    "autor":"'.$autor.'",
                    "genero":"'.$genero.'",
                    "portada":"'.$portada.'"
                },';
    }
    $arr = trim($arr, ',');
    $arr.=']';
    echo $arr;
}
else
{
    $arr.='[{"titulo":"","id_libro":0,"isbn":"","portada":""}]';
    echo $arr;
}


?>