<?php
header('Content-type: application/json');
require_once "funcions.php";

if( isset($_POST['id_libro']) &&  isset($_POST['id_usuario']))
{
    $id_libro = trim($_POST['id_libro']);
    $id_usuario = trim($_POST['id_usuario']);
    $dbMySQL = connexioMySql();
    $stmt = $dbMySQL->prepare("SELECT titol, ISBN, autor, genere, extensio_portada FROM llibres, llibre_autor, autors , llibre_genere, generes WHERE
                               llibres.id_llibre =:id_libro AND
                               llibre_autor.id_llibre = llibres.id_llibre AND
                               llibre_autor.id_autor = autors.id_autor AND
                               llibre_genere.id_llibre = llibres.id_llibre AND
                               llibre_genere.id_genere = generes.id_genere");
    $stmt->bindParam(":id_libro", $id_libro, PDO::PARAM_INT);
    $stmt->execute();

    if($stmt->rowCount()>0)
    {
        $row = $stmt->fetch(PDO::FETCH_ASSOC);
        $titulo = $row ['titol'];
        $isbn = $row ['ISBN'];
        $autor = $row ['autor'];
        $genero = utf8_encode($row ['genere']);
        $extension = $row ['extensio_portada'];

        $stmt2 = $dbMySQL->prepare("SELECT * FROM opinions_llibre WHERE id_llibre=:id_libro");
        $stmt2->bindParam(":id_libro", $id_libro, PDO::PARAM_INT);
        $stmt2->execute();
        $totalValoracions = $stmt2->rowCount();

        if($totalValoracions>0){
            $stmt2 = $dbMySQL->prepare("SELECT sum(nota)as nota FROM opinions_llibre WHERE id_llibre=:id_libro");
            $stmt2->bindParam(":id_libro", $id_libro, PDO::PARAM_INT);
            $stmt2->execute();
            $row2 = $stmt2->fetch(PDO::FETCH_ASSOC);
            $notaTotal = $row2['nota']/ $totalValoracions;
        }
        else{
            $notaTotal = 7;
        }

        $notaTotal = number_format($notaTotal,1);

        $ruta="../portadas/".$id_libro.".".$extension;
        if (file_exists($ruta)) {
            $data = file_get_contents($ruta);
            $portada = base64_encode($data);
        }
        else{
            $portada = "-";
        }

        $flag=0;
        $stmt2 = $dbMySQL->prepare("SELECT * FROM biblioteca WHERE id_usuari=:id_usuario and id_llibre=:id_libro and flag=:flag");
        $stmt2->bindParam(":id_usuario", $id_usuario, PDO::PARAM_INT);
        $stmt2->bindParam(":id_libro", $id_libro, PDO::PARAM_INT);
        $stmt2->bindParam(":flag", $flag, PDO::PARAM_INT);
        $stmt2->execute();
        $en_biblioteca=0;
        if($stmt2->rowCount()>0)
        {
            $en_biblioteca=1;
        }
		
		$stmt2 = $dbMySQL->prepare("SELECT * FROM llibres_desitjats WHERE id_usuari=:id_usuario and id_llibre=:id_libro");
        $stmt2->bindParam(":id_usuario", $id_usuario, PDO::PARAM_INT);
        $stmt2->bindParam(":id_libro", $id_libro, PDO::PARAM_INT);
        $stmt2->execute();
        $deseado=0;
        if($stmt2->rowCount()>0)
        {
            $deseado=1;
        }
		
		$stmt2 = $dbMySQL->prepare("SELECT * FROM opinions_llibre WHERE id_usuari=:id_usuario and id_llibre=:id_libro");
        $stmt2->bindParam(":id_usuario", $id_usuario, PDO::PARAM_INT);
        $stmt2->bindParam(":id_libro", $id_libro, PDO::PARAM_INT);
        $stmt2->execute();
        $notaUsuario =7;
		$opinion="";
        if($stmt2->rowCount()>0)
        {
			$row = $stmt2->fetch(PDO::FETCH_ASSOC);
            $notaUsuario=number_format($row ['nota'],0);
			$opinionUsuario=$row ['opinio'];
			$buscar=array( "\r\n", "\n", "\r");
			$reemplazar=array("\r\\n", "\\n", "\\r");
			$opinionUsuario=str_replace("\n"," ",$opinionUsuario);
        }
		
		$en_cambio=0;
		$flag=0;
		$stmt2 = $dbMySQL->prepare("SELECT * FROM llibres_canvi WHERE id_usuari=:id_usuario and id_llibre=:id_libro and flag=:flag");
        $stmt2->bindParam(":id_usuario", $id_usuario, PDO::PARAM_INT);
        $stmt2->bindParam(":id_libro", $id_libro, PDO::PARAM_INT);
		$stmt2->bindParam(":flag", $flag, PDO::PARAM_INT);
        $stmt2->execute();
        if($stmt2->rowCount()>0)
        {
			$en_cambio=1;
        }
		
		

       echo '{"success":1,"titulo":"'.$titulo.'","isbn":"'.$isbn.'","autor":"'.$autor.'","genero":"'.$genero.'","portada":"'.$portada.'","nota":"'.$notaTotal.'", "en_biblioteca":'.$en_biblioteca.', "deseado":'.$deseado.',  "en_cambio":'.$en_cambio.',"notaUsuario":"'.$notaUsuario.'", "opinionUsuario":"'.$opinionUsuario.'"}';
    }
    else
    {
        echo '{"success":0,"error_message":"El libro no existe."}';
    }
}
else
{
    echo '{"success":0,"error_message":"Datos inválidos."}';
}

?>