<?php 
header('Content-type: application/json');
require_once "funcions.php"; 
 
if( isset($_POST['titulo']) &&  isset($_POST['autor']) && isset($_POST['id_genero']) && isset($_POST['idioma']) && isset($_POST['editorial']) && isset($_POST['sinopis']) && isset($_POST['isbn']) ) {
	$titulo = trim($_POST['titulo']);
	$autor = trim($_POST['autor']);
	$id_genero = trim($_POST['id_genero']);
	$idioma = trim($_POST['idioma']);
	$editorial = trim($_POST['editorial']);
	$sinopis = trim($_POST['sinopis']);
	$isbn = trim($_POST['isbn']);
	$data_alta=date('Y-m-d H:i:s');
	
	$dbMySQL = connexioMySql();
	
	try { 
        $dbMySQL->beginTransaction(); 
	
		$stmt = $dbMySQL->prepare("SELECT * FROM autors WHERE autor =:autor");
		$stmt->bindParam(":autor", $autor, PDO::PARAM_STR);
		$stmt->execute();
		if($stmt->rowCount()>0)
		{
			$row = $stmt->fetch(PDO::FETCH_ASSOC);
			$id_autor = $row ['id_autor'];
		}
		else
		{
			$stmt = $dbMySQL->prepare("insert autors (autor) values (:autor)");
			$stmt->bindParam(":autor", $autor, PDO::PARAM_INT);
			$stmt->execute();
			$id_autor = $dbMySQL->lastInsertId(); 
		}
		
		$stmt = $dbMySQL->prepare("insert llibres (ISBN, titol, sinopsis, data_entrada) values (:isbn, :titol, :sinopsis, :fecha_entrada)");
		$stmt->bindParam(":isbn", $isbn, PDO::PARAM_STR);
		$stmt->bindParam(":titol", $titulo, PDO::PARAM_STR);
		$stmt->bindParam(":sinopsis", $sinopis, PDO::PARAM_STR);
		$stmt->bindParam(":fecha_entrada", $data_alta, PDO::PARAM_STR);
		$stmt->execute();
		$id_libro = $dbMySQL->lastInsertId(); 
		
		
		$stmt = $dbMySQL->prepare("insert llibre_genere (id_llibre, id_genere) values (:id_libro, :id_genero)");
		$stmt->bindParam(":id_libro", $id_libro, PDO::PARAM_INT);
		$stmt->bindParam(":id_genero", $id_genero, PDO::PARAM_INT);
		$stmt->execute();
		
			
		$stmt = $dbMySQL->prepare("insert llibre_autor (id_llibre, id_autor) values (:id_libro, :id_autor)");
		$stmt->bindParam(":id_libro", $id_libro, PDO::PARAM_INT);
		$stmt->bindParam(":id_autor", $id_autor, PDO::PARAM_INT);
		$stmt->execute();
		
		
		if($idioma != ""){
		
			$stmt = $dbMySQL->prepare("SELECT * FROM idiomes WHERE idioma =:idioma");
			$stmt->bindParam(":idioma", $idioma, PDO::PARAM_STR);
			$stmt->execute();
			if($stmt->rowCount()>0)
			{
				$id_idioma = $row ['id_idioma'];
			}
			else{
				$stmt = $dbMySQL->prepare("insert idiomes (idioma) values (:idioma)");
				$stmt->bindParam(":idioma", $idioma, PDO::PARAM_STR);
				$stmt->execute();
				$id_idioma = $dbMySQL->lastInsertId(); 
			}
			
			$stmt = $dbMySQL->prepare("update llibres set id_idioma =:id_idioma where id_libro=:id_libro");
			$stmt->bindParam(":id_idioma", $id_idioma, PDO::PARAM_INT);
			$stmt->bindParam(":id_libro", $id_libro, PDO::PARAM_INT);
			$stmt->execute();
		}
	
		$dbMySQL->commit(); 
		echo '{"success":1,"id_libro":'.$id_libro.'}';
	}
	catch(PDOExecption $e) { 
        $dbMySQL->rollback(); 
		//echo ($e->getMessage());
		echo '{"success":0,"error_message":"'.$e->getMessage().'"}';
    } 
	
}
else{
	echo '{"success":0,"error_message":"Datos inválidos."}';
}