<?php
header('Content-type: application/json');
require_once "funcions.php";

if( isset($_POST['id_usuario']) )
{
    $id_usuario = trim($_POST['id_usuario']);
	$flag=0;
    $dbMySQL = connexioMySql();
	
	$stmt = $dbMySQL->prepare("SELECT sum(puntuacio) as puntuacion FROM valoracions where id_usuari_valorat=:id_usuario");
	$stmt->bindParam(":id_usuario", $id_usuario, PDO::PARAM_INT);
    $stmt->execute();
	$row = $stmt->fetch(PDO::FETCH_ASSOC);
	$nota=$row['puntuacion'];
	
	if(! is_null($nota)){
		$stmt = $dbMySQL->prepare("SELECT * FROM valoracions where id_usuari_valorat=:id_usuario");
		$stmt->bindParam(":id_usuario", $id_usuario, PDO::PARAM_INT);
    	$stmt->execute();
		$nota=number_format($nota / $stmt->rowCount(),2);
	}
	else
	{
		$nota= " - ";
	}
	
	
    $stmt = $dbMySQL->prepare("SELECT * FROM llibres_canvi, llibres, llibre_autor, autors, llibre_genere, generes
                              WHERE llibres_canvi.id_llibre = llibres.id_llibre and
                                    llibres_canvi.id_usuari=:id_usuario and
                                    llibre_autor.id_llibre=llibres.id_llibre AND
                                    llibre_autor.id_autor = autors.id_autor and
                                    llibre_genere.id_llibre=llibres.id_llibre AND
                                    llibre_genere.id_genere = generes.id_genere and
									llibres_canvi.flag=:flag
                              order by titol,autor");
    $stmt->bindParam(":id_usuario", $id_usuario, PDO::PARAM_INT);
	$stmt->bindParam(":flag", $flag, PDO::PARAM_INT);
    $stmt->execute();
	
    $arr='[';
    while($row = $stmt->fetch(PDO::FETCH_ASSOC))
    {
        $titulo=$row['titol'];
        $id_libro=$row['id_llibre'];
		$id=$row['id_llibre_canvi'];
        $isbn=$row['ISBN'];
        $autor=$row['autor'];
        $genero=utf8_encode($row['genere']);
        $extension = $row['extensio_portada'];
		$extension_im = $row['extensio_imatge'];
		$observacion=$row['observacio'];

        $ruta="../portadas/".$id_libro.".".$extension;
        if (file_exists($ruta)) {
            $data = file_get_contents($ruta);
            $portada = base64_encode($data);
        }
        else{
            $portada = "-";
        }
		
		$ruta="../imagenes/".$id.".".$extension_im;
        if (file_exists($ruta)) {
            $data = file_get_contents($ruta);
            $imagen = base64_encode($data);
        }
        else{
            $imagen = "-";
        }

        $arr.='{
                    "titulo":"'.$titulo.'",
                    "id_libro":'.$id_libro.',
					"id":'.$id.',
                    "isbn":"'.$isbn.'",
                    "autor":"'.$autor.'",
                    "genero":"'.$genero.'",
					"observacion":"'.$observacion.'",
                    "portada":"'.$portada.'",
					"imagen":"'.$imagen.'",
					"nota":"'.$nota.'"
                },';
    }
    $arr = trim($arr, ',');
    $arr.=']';
    echo $arr;
}



?>