<?php
header('Content-type: application/json');
require_once "funcions.php";


if( isset($_POST['tipo']) &&  isset($_POST['texto']))
{
		
	$tipo = trim($_POST['tipo']);
	$texto =trim($_POST['texto']);

	$dbMySQL = connexioMySql();
	 
	if($tipo == 0) // buscamos por título
	{	
		$var = "%".$texto."%";
		$stmt = $dbMySQL->prepare("SELECT llibres.id_llibre,titol, ISBN, autor, genere, extensio_portada 
									FROM llibres, llibre_autor, autors , llibre_genere, generes 
									WHERE
									   llibres.titol LIKE :var AND
									   llibre_autor.id_llibre = llibres.id_llibre AND
									   llibre_autor.id_autor = autors.id_autor AND
									   llibre_genere.id_llibre = llibres.id_llibre AND
									   llibre_genere.id_genere = generes.id_genere
							   ORDER BY titol");
		$stmt->bindParam(":var", $var, PDO::PARAM_STR);
	}
	else
	{
		if($tipo == 2) //Buscamos por ISBN
		{
			$var = "%".$texto."%";
			$stmt = $dbMySQL->prepare("SELECT llibres.id_llibre,titol, ISBN, autor, genere, extensio_portada 
									FROM llibres, llibre_autor, autors , llibre_genere, generes 
									WHERE
									   llibres.ISBN LIKE :var AND
									   llibre_autor.id_llibre = llibres.id_llibre AND
									   llibre_autor.id_autor = autors.id_autor AND
									   llibre_genere.id_llibre = llibres.id_llibre AND
									   llibre_genere.id_genere = generes.id_genere
							   ORDER BY titol");
			$stmt->bindParam(":var", $var, PDO::PARAM_STR);
		}
		else
		{
			if($tipo == 1) //Buscamos por autor
			{
				$var = "%".$texto."%";
				$stmt = $dbMySQL->prepare("SELECT llibres.id_llibre,titol, ISBN, autor, genere, extensio_portada 
										FROM llibres, llibre_autor, autors , llibre_genere, generes 
										WHERE
											autors.autor LIKE :var AND
										   llibre_autor.id_llibre = llibres.id_llibre AND
										   llibre_autor.id_autor = autors.id_autor AND
										   llibre_genere.id_llibre = llibres.id_llibre AND
										   llibre_genere.id_genere = generes.id_genere
								   ORDER BY titol");
				$stmt->bindParam(":var", $var, PDO::PARAM_STR);
			}
		}
	}
	

	
	$stmt->execute();
	

	
	$arr='[';
 	while($row = $stmt->fetch(PDO::FETCH_ASSOC))
	{
		$titulo = $row ['titol'];
		$id_libro = $row ['id_llibre'];
        $isbn = $row ['ISBN'];
        $autor = $row ['autor'];
		$genero = utf8_encode($row ['genere']);
        $extension = $row ['extensio_portada'];
		
		$ruta="../portadas/".$id_libro.".".$extension;
        if (file_exists($ruta)) {
            $data = file_get_contents($ruta);
            $portada = base64_encode($data);
        }
        else{
            $portada = "-";
        }

        $arr.='{
                    "id_libro":'.$id_libro.',
					"titulo":"'.$titulo.'",
                    "isbn":"'.$isbn.'",
					"genero":"'.$genero.'",
					"autor":"'.$autor.'",
					"portada":"'.$portada.'"
                },';	
    }
    $arr = trim($arr, ',');
    $arr.=']';

  	 echo $arr;
}
else{
	
}


?>