//
//  BusquedaController.swift
//  trotalibros
//
//  Created by EDU on 26/11/16.
//  Copyright © 2016 EDU. All rights reserved.
//  Clase dónde se seleciona como hacer la búsqueda

import Foundation
import UIKit
import QuartzCore

class BusquedaController: UIViewController {
    
     //variables conectadas con los elementos de la pantalla
    @IBOutlet weak var tipoSelector: UISegmentedControl!
    @IBOutlet weak var textoField: UITextField!
    
    //variables internas
    var tipo: Int = 0
    
    
    //Se seleciona el parámetro donde se hace la búsqueda
    @IBAction func buscar(_ sender: AnyObject) {
        if (textoField.text!.isEmpty)
        {
            SCLAlertView().showWarning("ATENCIÓN", subTitle: "Todos los campos son obligatorios",closeButtonTitle:"OK")
        }
        else
        {
            switch tipoSelector.selectedSegmentIndex // seleccionamos la opción marcada
            {
            case 0:
                tipo = 0
            case 1:
                tipo = 1
            case 2:
                tipo = 2
            default:
                break;
            }
            
            //cambiamos de pantalla
             self.performSegue(withIdentifier: "goToResultado", sender: self)
        }
    }
    
     //Se preparan los parámetros para cambiar de pantalla
    override func prepare(for segue: UIStoryboardSegue, sender: Any?) {
        if segue.identifier == "goToResultado" {
            let vc = segue.destination as! ResultadoController
            vc.tipo = tipo
            vc.texto = textoField.text!
        }
    }
    
    override func didReceiveMemoryWarning()
    {
        super.didReceiveMemoryWarning()
    }
    
    override func viewDidLoad()
    {
        super.viewDidLoad()
    }
    
    //Escondemos el teclado
    func textFieldShouldReturn(textField: UITextField) -> Bool {
        textoField.resignFirstResponder()
        return true;
    }
    
   //Escondemos el teclado al tocar el fondo de pantalla
    override func touchesBegan(_ touches: Set<UITouch>, with event: UIEvent?) {
        textoField.resignFirstResponder()
        self.view.endEditing(true)
    }
}

