//
//  CambiarLibroPaso1Controller.swift
//  trotalibros
//
//  Created by Andorsoft on 1/12/16.
//  Copyright © 2016 EDU. All rights reserved.
//  Clase para seleccinar los libros a cambiar


import UIKit
import QuartzCore

class CambiarLibroPaso1Controller: UIViewController, UIPickerViewDataSource, UIPickerViewDelegate  {
    
    //variables internas
    var id_usuario: Int = 0
    var nombre_usuario: String = ""
    var imagen: String = ""
    var valoracion: String = ""
    var id_libro: Int = 0
    var titulo_libro_pido: String = ""
    var titulo_libro_ofrezco: String = ""
    var descripcion: String = ""
    var id_libro_pido : Int = 0
    var id_libro_ofrezco : Int = 0
    var titulos: [String] = []
    var ids: [Int] = []
    
    //variables conectadas con los elementos de la pantalla
    @IBOutlet weak var nombreUsuarioLabel: UILabel!
    @IBOutlet weak var valoracionLabel: UILabel!
    @IBOutlet weak var tituloLabel: UILabel!
    @IBOutlet weak var descripcionText: UITextView!
    @IBOutlet weak var librosSelector: UIPickerView!
    
    @IBAction func infoButton(_ sender: AnyObject) {
        self.performSegue(withIdentifier: "goToEjemplar3", sender: self)
    }
   
    //Pasamos a la siguiente pantalla
    @IBAction func siguiente(_ sender: AnyObject) {
        
        // cogemos la posición seleccionada del picker
        let x = librosSelector.selectedRow(inComponent: 0)
        id_libro_ofrezco = ids[x];
        titulo_libro_ofrezco = titulos[x];
        self.performSegue(withIdentifier: "goToPaso2", sender: self)
    }
    
    
    //Se obtenien lso libros a trotar del usuario
    func obtenerLibros(){
        
        let prefs:UserDefaults = UserDefaults.standard
        var id_usuarioPide=prefs.string(forKey: "IDUSUARIO")! as String
        
        var post:NSString = "id_usuario=\(id_usuarioPide)" as NSString
        
        var ruta = Utils.agafaRuta(string: "libros_trotados_usuario.php")
        let url:NSURL = NSURL(string: ruta as String)!
        
        let postData:NSData = post.data(using: String.Encoding.ascii.rawValue)! as NSData
        
        let postLength:NSString = String( postData.length ) as NSString
        
        let request:NSMutableURLRequest = NSMutableURLRequest(url: (url as NSURL) as URL)
        request.httpMethod = "POST"
        request.httpBody = postData as Data
        request.setValue(postLength as String, forHTTPHeaderField: "Content-Length")
        request.setValue("application/x-www-form-urlencoded", forHTTPHeaderField: "Content-Type")
        request.setValue("application/json", forHTTPHeaderField: "Accept")
        
        var reponseError: NSError?
        var response: URLResponse?
        
        var urlData: NSData?
        do {
            urlData = try NSURLConnection.sendSynchronousRequest(request as URLRequest, returning:&response) as NSData?
        } catch var error as NSError {
            reponseError = error
            urlData = nil
        }
        
        if ( urlData != nil ) {
            let res = response as! HTTPURLResponse!;
            
            var responseData:NSString  = NSString(data:urlData! as Data, encoding:String.Encoding.utf8.rawValue)!
            
            NSLog("Response ==> %@", responseData);
            
            if ((res?.statusCode)! >= 200 && (res?.statusCode)! < 300)
            {
                let json = JSON(data: urlData! as Data)
                
                //guardamos en un array los libros para pasarlos el pickerview
                if(json.count>0){
                    for index in 0...(json.count-1)
                    {
                        titulos.append((json[index]["titulo"].stringValue as NSString) as String)
                        ids.append((json[index]["id"].intValue) )
                    }
                }
            }
            else
            {
                SCLAlertView().showError("Error", subTitle:"La connexión falló", closeButtonTitle:"Cerrar")
                
            }
        }
        else
        {
            SCLAlertView().showError("Error", subTitle:"La connexión falló2", closeButtonTitle:"Cerrar")
            
        }
    }
    
    func numberOfComponents(in pickerView: UIPickerView) -> Int {
        return 1
    }
    
    func pickerView(_ pickerView: UIPickerView, numberOfRowsInComponent component: Int) -> Int {
        return titulos.count;
    }
    
    func pickerView(_ pickerView: UIPickerView, titleForRow row: Int, forComponent component: Int) -> String? {
        return titulos[row]
    }
    
    func pickerView(_ pickerView: UIPickerView, didSelectRow row: Int, inComponent component: Int)
    {
        print(row)
    }
    
    //Rellemanos el picker con los títulos de los libros
    func pickerView(_ pickerView: UIPickerView, viewForRow row: Int, forComponent component: Int, reusing view: UIView?) -> UIView {
        var label: UILabel
        
        if let view = view as? UILabel
        {
            label = view
        }
        else
        {
            label = UILabel()
        }
        
        label.textColor = .black
        label.textAlignment = .center
        //label.font = UIFont(name: "SanFranciscoText-Light", size: 18)
        
        //Ponemos el título en el label del picker
        label.text = titulos[row]
        
        return label
    }
    
    
    // Se prepara el cambio de pantalla com el paso de parámetros
    override func prepare(for segue: UIStoryboardSegue, sender: Any?)
    {
        
        if segue.identifier == "goToPaso2" {
            let vc = segue.destination as! CambiarLibroPaso2Controller
            vc.id_libro_pido = id_libro_pido
            vc.id_libro_ofrezco = id_libro_ofrezco
            vc.nombre_usuario = nombre_usuario
            vc.id_usuario = id_usuario
            vc.titulo_libro_pido = titulo_libro_pido
            vc.titulo_libro_ofrezco = titulo_libro_ofrezco
           
        }
        if segue.identifier == "goToEjemplar3" {
            let vc = segue.destination as! InfoLibroCambioController
            vc.observacion = descripcion as NSString
            vc.imagen = imagen as NSString
            
        }
 

    }
    
    override func didReceiveMemoryWarning() {
        super.didReceiveMemoryWarning()
    }
    

    //Función al cargar la pantalla la primera vez
    override func viewDidLoad()
    {
        super.viewDidLoad()
        obtenerLibros();
        librosSelector.dataSource = self;
        librosSelector.delegate = self;
        tituloLabel.text = titulo_libro_pido
        descripcionText.text = descripcion
    }
}
