//
//  CambiarLibroPaso1Controller.swift
//  trotalibros
//
//  Created by Andorsoft on 1/12/16.
//  Copyright © 2016 EDU. All rights reserved.
//  Clase que genera una permuta


import UIKit
import QuartzCore

class CambiarLibroPaso2Controller: UIViewController  {
    
    //variables internas
    var id_usuario: Int = 0
    var nombre_usuario: String = ""
    var titulo_libro_pido: String = ""
    var titulo_libro_ofrezco: String = ""
    var id_libro_pido : Int = 0
    var id_libro_ofrezco : Int = 0

    //variables conectadas con los elementos de la pantalla
    @IBOutlet weak var tituloPido: UILabel!
    @IBOutlet weak var tituloOfrezco: UILabel!
    @IBOutlet weak var comentarioText: UITextView!
    
    
    //Se envia los datos por POST al servidor de la permuta que se crea
    @IBAction func crearPermuta(_ sender: AnyObject) {
        
        let prefs:UserDefaults = UserDefaults.standard
        var id_usuario_emisor=prefs.string(forKey: "IDUSUARIO")! as String
        
        let post:NSString = "comentario=\(comentarioText.text!)&id_usuario_emisor=\(id_usuario_emisor)&id_usuario_receptor=\(id_usuario)&id_libro_emisor=\(id_libro_ofrezco)&id_libro_receptor=\(id_libro_pido)" as NSString
        
        print(post);
        let ruta = Utils.agafaRuta(string: "hacer_permuta.php")
        let url:NSURL = NSURL(string: ruta as String)!
            
        let postData:NSData = post.data(using: String.Encoding.utf8.rawValue)! as NSData
            
        let postLength:NSString = String( postData.length ) as NSString
            
        let request:NSMutableURLRequest = NSMutableURLRequest(url: (url as NSURL) as URL)
        request.httpMethod = "POST"
        request.httpBody = postData as Data
        request.setValue(postLength as String, forHTTPHeaderField: "Content-Length")
        request.setValue("application/x-www-form-urlencoded", forHTTPHeaderField: "Content-Type")
        request.setValue("application/json", forHTTPHeaderField: "Accept")
            
        var reponseError: NSError?
        var response: URLResponse?
            
        var urlData: NSData?
        do
        {
            urlData = try NSURLConnection.sendSynchronousRequest(request as URLRequest, returning:&response) as NSData?
        }
        catch var error as NSError
        {
            reponseError = error
            urlData = nil
        }
            
        if ( urlData != nil )
        {
            let res = response as! HTTPURLResponse!;
                
            NSLog("Response code: %ld", String(describing: res?.statusCode));
            var responseData:NSString  = NSString(data:urlData! as Data, encoding:String.Encoding.utf8.rawValue)!
                
            if ((res?.statusCode)! >= 200 && (res?.statusCode)! < 300)
            {
                var responseData:NSString  = NSString(data:urlData! as Data, encoding:String.Encoding.utf8.rawValue)!
                    
                NSLog("Response ==> %@", responseData);
                    
                var error: NSError?
                    
                let jsonData:NSDictionary = (try! JSONSerialization.jsonObject(with: urlData! as Data, options:JSONSerialization.ReadingOptions.mutableContainers )) as! NSDictionary
                    
                let success:NSInteger = jsonData.value(forKey: "success") as! NSInteger
                    
                NSLog("Success: %ld", success);
                
                //Si OK se confirma al usuario
                if(success == 1)
                {
                    let appearance = SCLAlertView.SCLAppearance(
                        showCloseButton: false
                    )
                    let alertView = SCLAlertView(appearance: appearance)
                    alertView.addButton("Cerrar", target:self, selector:Selector("volver"))
                    alertView.showSuccess("", subTitle: "¡Permuta enviada a " + nombre_usuario)
                }
                else
                {
                    var error_msg:NSString
                        
                    if jsonData["error_message"] as? NSString != nil
                    {
                        error_msg = jsonData["error_message"] as! NSString
                    }
                    else
                    {
                        error_msg = "Unknown Error"
                    }
                    SCLAlertView().showError("Error", subTitle:error_msg as String, closeButtonTitle:"Cerrar")
                }
                    
            }
            else
            {
                    SCLAlertView().showError("Error", subTitle:"La connexión falló", closeButtonTitle:"Cerrar")
            }
        }
        else
        {
                SCLAlertView().showError("Error", subTitle:"La connexión falló2", closeButtonTitle:"Cerrar")
        }
    }
    
    
    func volver()
    {
     self.performSegue(withIdentifier: "goToPermutas2", sender: self)
    }
    
    
    //Función al cargar la pantalla la primera vez
    override func viewDidLoad()
    {
        super.viewDidLoad()
        self.title = "Paso 2"
        tituloOfrezco.text = titulo_libro_ofrezco
        tituloPido.text = titulo_libro_pido
    }
    
    func textFieldShouldReturn(textField: UITextField) -> Bool {
        comentarioText.resignFirstResponder()
        return true;
    }
    
    //textfield func for the touch on BG
    override func touchesBegan(_ touches: Set<UITouch>, with event: UIEvent?) {
        comentarioText.resignFirstResponder()
        self.view.endEditing(true)
    }
    
    override func didReceiveMemoryWarning() {
        super.didReceiveMemoryWarning()
    }
}
