//
//  EntrarOpinionController.swift
//  trotalibros
//
//  Created by EDU on 27/11/16.
//  Copyright © 2016 EDU. All rights reserved.
//  Clase para crear una opinión de un  libro

import Foundation
import UIKit
import QuartzCore

class EntrarOpinionController: UIViewController {
    
    //variables conectadas con los elementos de la pantalla
    @IBOutlet weak var aceptarButton: UIButton!
    @IBOutlet weak var notaSelector: UISlider!
    @IBOutlet weak var opinionText: UITextView!
    @IBOutlet weak var notaLabel: UILabel!
    
    //variables internas
    var id_libro = 0
    var nota: NSString = " "
    var opinion: NSString = " "
    
    
    //Se envía por POST la información de la opinión a crear
    @IBAction func guardarOpinion(_ sender: AnyObject) {
        if (opinionText.text!.isEmpty){
            SCLAlertView().showWarning("ATENCIÓN", subTitle: "Todos los campos son obligatorios",closeButtonTitle:"OK")
        }
            
        else{
            
            let prefs:UserDefaults = UserDefaults.standard
            var id_usuario=prefs.string(forKey: "IDUSUARIO")! as String
            
            var post:NSString = "opinion=\(opinionText.text!)&nota=\(Int(notaSelector.value))&id_usuario=\(id_usuario)&id_libro=\(id_libro)" as NSString
            
            var ruta = Utils.agafaRuta(string: "crear_opinion.php")
            let url:NSURL = NSURL(string: ruta as String)!
            
            let postData:NSData = post.data(using: String.Encoding.utf8.rawValue)! as NSData
            
            let postLength:NSString = String( postData.length ) as NSString
            
            let request:NSMutableURLRequest = NSMutableURLRequest(url: (url as NSURL) as URL)
            request.httpMethod = "POST"
            request.httpBody = postData as Data
            request.setValue(postLength as String, forHTTPHeaderField: "Content-Length")
            request.setValue("application/x-www-form-urlencoded", forHTTPHeaderField: "Content-Type")
            request.setValue("application/json", forHTTPHeaderField: "Accept")
            
            
            var reponseError: NSError?
            var response: URLResponse?
            
            var urlData: NSData?
            do {
                urlData = try NSURLConnection.sendSynchronousRequest(request as URLRequest, returning:&response) as NSData?
            } catch var error as NSError {
                reponseError = error
                urlData = nil
            }
            
            if ( urlData != nil ) {
                let res = response as! HTTPURLResponse!;
                
                NSLog("Response code: %ld", String(describing: res?.statusCode));
                
                
                if ((res?.statusCode)! >= 200 && (res?.statusCode)! < 300)
                {
                    var responseData:NSString  = NSString(data:urlData! as Data, encoding:String.Encoding.utf8.rawValue)!
                    
                    NSLog("Response ==> %@", responseData);
                    
                    var error: NSError?
                    
                    let jsonData:NSDictionary = (try! JSONSerialization.jsonObject(with: urlData! as Data, options:JSONSerialization.ReadingOptions.mutableContainers )) as! NSDictionary
                    
                    let success:NSInteger = jsonData.value(forKey: "success") as! NSInteger
                    
                    //Si ok confirmamos al usuario con un popup
                    if(success == 1)
                    {
                        SCLAlertView().showSuccess("Opinión guardada", subTitle: "Gracias por tu aportación!")
                        aceptarButton.isHidden = true
                    }
                    else{
                            var error_msg:NSString
                            
                            if jsonData["error_message"] as? NSString != nil {
                                error_msg = jsonData["error_message"] as! NSString
                            } else {
                                error_msg = "Unknown Error"
                            }
                            SCLAlertView().showError("Error", subTitle:error_msg as String, closeButtonTitle:"Cerrar")
                    }
                    
                } else {
                    SCLAlertView().showError("Error", subTitle:"La connexión falló", closeButtonTitle:"Cerrar")
                    
                }
            }
            else
            {
                SCLAlertView().showError("Error", subTitle:"La connexión falló", closeButtonTitle:"Cerrar")
                
            }
            
        }

        
    }
    
    //Actualizamos la lebel con el valor seleccionado del slider
    @IBAction func notaSeleccion(_ sender: AnyObject) {
        var selectedValue = Int(notaSelector.value)
        notaLabel.text = String(stringInterpolationSegment: selectedValue)
    }
    
    //Función que se ejecuta al iniciar la pantalla la primera vez
    override func viewDidLoad()
    {
        super.viewDidLoad()
        notaLabel.text = nota as String
        notaSelector.value = (nota as NSString).floatValue
        opinionText.text = opinion as String
        self.title = "Opinión libro"
    }
    
    override func viewWillAppear(_ animated: Bool)
    {
        super.viewWillAppear(animated)
    }
    
    //Se prepara los parámetros para cambiar de pantalla
    override func prepare(for segue: UIStoryboardSegue, sender: Any?) {
        
        if segue.identifier == "goToLibro5" {
            let vc = segue.destination as! LibroController
            vc.id_libro = id_libro
        }
    }
    
    //Escodenmos el teclado 
    func textFieldShouldReturn(textField: UITextField) -> Bool {
        opinionText.resignFirstResponder()
        return true;
    }
    
    //Escodenmos el teclado al tocar el fondo de pantalla
    override func touchesBegan(_ touches: Set<UITouch>, with event: UIEvent?) {
        opinionText.resignFirstResponder()
        self.view.endEditing(true)
    }
}
