//
//  GenerosController.swift
//  trotalibros
//
//  Created by EDU on 26/11/16.
//  Copyright © 2016 EDU. All rights reserved.
//  Clase que muestra en formtato tabla los géneros

import Foundation
import UIKit
import QuartzCore

class GenerosController: UITableViewController {
    
    //variables internas
    var generos: [String] = []
    var id_generos: [Int] = []

    
    //Se obtienen todos los géneros de la base de datos
    func obtenerDatos(){

        var ruta = Utils.agafaRuta(string: "coge_generos.php")
        let url:NSURL = NSURL(string: ruta as String)!
        let request:NSMutableURLRequest = NSMutableURLRequest(url: (url as NSURL) as URL)
        request.setValue("application/x-www-form-urlencoded", forHTTPHeaderField: "Content-Type")
        request.setValue("application/json", forHTTPHeaderField: "Accept")
        
        var reponseError: NSError?
        var response: URLResponse?
        
        var urlData: NSData?
        do {
            urlData = try NSURLConnection.sendSynchronousRequest(request as URLRequest, returning:&response) as NSData?
        } catch var error as NSError {
            reponseError = error
            urlData = nil
        }
        
        if ( urlData != nil ) {
            let res = response as! HTTPURLResponse!;
            
            var responseData:NSString  = NSString(data:urlData! as Data, encoding:String.Encoding.utf8.rawValue)!
            
            if ((res?.statusCode)! >= 200 && (res?.statusCode)! < 300)
            {
                let json = JSON(data: urlData! as Data)
                
                if(json.count>0){
                    for index in 0...(json.count-1)
                    {
                        //guardamos cada género en arrays, cada una para un parámetro
                        generos.append((json[index]["genero"].stringValue as NSString) as String)
                        id_generos.append((json[index]["id_genero"].intValue) )
                    }
                }
            }
            else
            {
                SCLAlertView().showError("Error", subTitle:"La connexión falló", closeButtonTitle:"Cerrar")
                
            }
        }
        else
        {
            SCLAlertView().showError("Error", subTitle:"La connexión falló2", closeButtonTitle:"Cerrar")
            
        }
    }
    
    
    
    override func tableView(_ tableView: UITableView?, numberOfRowsInSection section: Int) -> Int
    {
        return self.generos.count;
    }
    
     //Rellenamos cada fila de la tabla con un género. cada elemento de la fila tiene un TAG que lo diferencia
    override func tableView(_ tableView: UITableView, cellForRowAt indexPath: IndexPath) -> UITableViewCell {
        let cell = tableView.dequeueReusableCell(withIdentifier: "generosCell", for: indexPath)
        
        if let generosLabel = cell.viewWithTag(100) as? UILabel
        {
            generosLabel.text = self.generos[indexPath.row]
        }
        
        return cell
    }
    
     //Se preparan los parámetros para cambiar de pantalla
    override func prepare(for segue: UIStoryboardSegue, sender: Any?) {
        
        let index = tableView.indexPathForSelectedRow!
        
        let id_genero = self.id_generos[index.row]
        let genero = self.generos[index.row]
        
       if segue.identifier == "goToResultadoGeneros" {
            let vc = segue.destination as! ResultadoGenerosController
            vc.id_genero = id_genero
            vc.genero = genero
        }
    }
    
    override func didReceiveMemoryWarning()
    {
        super.didReceiveMemoryWarning()
    }
    
     //Función que se ejecuta al cargar la pantalla la primera vez
    override func viewDidLoad()
    {
        super.viewDidLoad()
        self.title = "Géneros"
        obtenerDatos()
    }
}
