//
//  HacerValoracionController.swift
//  trotalibros
//
//  Created by EDU on 5/12/16.
//  Copyright © 2016 EDU. All rights reserved.
//  Clase para crear una valoración de  una permuta

import UIKit
import QuartzCore

class HacerValoracionController: UIViewController {
    
    //variabkles internas
    var id_usuario_valorado:Int = 0
    var id_permuta:Int = 0
    var nombre_usuario_valorado:NSString = ""
    
    
    //variables conectadas con los elementos de la pantalla
    @IBOutlet weak var puntuacion: UISlider!
    @IBOutlet weak var opinionText: UITextView!
    @IBOutlet weak var label: UILabel!
    @IBOutlet weak var puntuacionLabel: UILabel!
    @IBOutlet weak var valorarButton: UIButton!
    
    
    //Función para escribir en un label el valor del slider
    @IBAction func puntuacionSelecion(_ sender: AnyObject) {
        var selectedValue = Int(puntuacion.value)
        puntuacionLabel.text = String(stringInterpolationSegment: selectedValue)
    }
    
    
    //Función para crear una valoración, los parámetros se envian por POST al servidor
    @IBAction func valorar(_ sender: AnyObject) {
        
        let prefs:UserDefaults = UserDefaults.standard
        var id_usuario=prefs.string(forKey: "IDUSUARIO")! as String
        var post:NSString = "id_permuta=\(id_permuta)&id_usuario=\(id_usuario)&id_usuario_valorado=\(id_usuario_valorado)&opinion=\(opinionText.text!)&puntuacion=\(puntuacionLabel.text!)" as NSString
        
        var ruta = Utils.agafaRuta(string: "valorar_permuta.php")
        let url:NSURL = NSURL(string: ruta as String)!
        
        let postData:NSData = post.data(using: String.Encoding.utf8.rawValue)! as NSData
        
        let postLength:NSString = String( postData.length ) as NSString
        
        let request:NSMutableURLRequest = NSMutableURLRequest(url: (url as NSURL) as URL)
        request.httpMethod = "POST"
        request.httpBody = postData as Data
        request.setValue(postLength as String, forHTTPHeaderField: "Content-Length")
        request.setValue("application/x-www-form-urlencoded", forHTTPHeaderField: "Content-Type")
        request.setValue("application/json", forHTTPHeaderField: "Accept")
        
        
        var reponseError: NSError?
        var response: URLResponse?
        
        var urlData: NSData?
        do {
            urlData = try NSURLConnection.sendSynchronousRequest(request as URLRequest, returning:&response) as NSData?
        } catch var error as NSError {
            reponseError = error
            urlData = nil
        }
        
        if ( urlData != nil ) {
            let res = response as! HTTPURLResponse!;
            
            var responseData:NSString  = NSString(data:urlData! as Data, encoding:String.Encoding.utf8.rawValue)!
            
            NSLog("Response ==> %@", responseData);
            
            if ((res?.statusCode)! >= 200 && (res?.statusCode)! < 300)
            {
                var responseData:NSString  = NSString(data:urlData! as Data, encoding:String.Encoding.utf8.rawValue)!
                
                var error: NSError?
                
                let jsonData:NSDictionary = (try! JSONSerialization.jsonObject(with: urlData! as Data, options:JSONSerialization.ReadingOptions.mutableContainers )) as! NSDictionary
                
                let success:NSInteger = jsonData.value(forKey: "success") as! NSInteger
                
                //Si OK mostramos un mensaje en popup y no dejamos entrar otra valoración
                if(success == 1)
                {
                    valorarButton.isHidden = true
                    opinionText.isEditable = false
                    let alert = SCLAlertView()
                    alert.showSuccess("", subTitle: "¡Gracias por tu valoración!",closeButtonTitle:"Cerrar")

                } else {
                    var error_msg:NSString
                    
                    if jsonData["error_message"] as? NSString != nil {
                        error_msg = jsonData["error_message"] as! NSString
                    } else {
                        error_msg = "Unknown Error"
                    }
                    SCLAlertView().showError("Error", subTitle:error_msg as String, closeButtonTitle:"Cerrar")
                }
                
            } else {
                SCLAlertView().showError("Error", subTitle:"La connexión falló", closeButtonTitle:"Cerrar")
                
            }
        } else {
            SCLAlertView().showError("Error", subTitle:"La connexión falló2", closeButtonTitle:"Cerrar")
            
        }

    }
    
     //Función al cargar la pantalla la primera vez
    override func viewDidLoad()
    {
        super.viewDidLoad()
        self.title = "Valoración"
        puntuacionLabel.text = "5"
        label.text = "Puntua del 1 al 10 a " + (nombre_usuario_valorado as String)
    }
    
    override func viewWillDisappear(_ animated : Bool) {
        super.viewWillDisappear(animated)
    }
    
    override func viewWillAppear(_ animated: Bool)
    {
        super.viewWillAppear(animated)
    }
    
    override func didReceiveMemoryWarning() {
        super.didReceiveMemoryWarning()
    }
    
    //Escondemos el teclado
    func textFieldShouldReturn(textField: UITextField) -> Bool {
        opinionText.resignFirstResponder()
        return true;
    }
    
    //Escondemos el teclado al tocar el fondo de pantalla
    override func touchesBegan(_ touches: Set<UITouch>, with event: UIEvent?) {
        opinionText.resignFirstResponder()
        self.view.endEditing(true)
    }
    
}
