//
//  LibroController.swift
//  trotalibros
//
//  Created by Andorsoft on 17/11/16.
//  Copyright © 2016 EDU. All rights reserved.
//  Clase que muestra la información de un libro y sus respectivas acciones


import Foundation
import UIKit
import QuartzCore

class LibroController: UIViewController {
    
     //variables conectadas con los elementos de la pantalla
    @IBOutlet weak var portadaImagen: UIImageView!
    @IBOutlet weak var opcionesButton: UIButton!
    @IBOutlet weak var opinionesButton: UIButton!
    @IBOutlet weak var isbnLabel: UILabel!
    @IBOutlet weak var generoLabel: UILabel!
    @IBOutlet weak var autorLabel: UILabel!
    @IBOutlet weak var tituloLabel: UILabel!
    @IBOutlet weak var calificacionButton: UIButton!
    
    //variables internas
    var id_libro = 0
    var flag = 0
    var portada: NSString = " "
    var en_biblioteca = 0
    var deseado = 0
    var en_cambio=0;
    var notaUsuario: NSString = " "
    var opinionUsuario: NSString = " "
    
    
    //cambiamos de pantalla al pulsar el botón conectado con esta función
    func leerOpiniones() {
        self.performSegue(withIdentifier: "goToOpiniones", sender: self)
    }
    
    //cambiamos de pantalla al pulsar el botón conectado con esta función
    func nuevaOpinion() {
        self.performSegue(withIdentifier: "goToNuevaOpinion", sender: self)
    }
    
    
    //Menú con todas las opciones disponibles
    @IBAction func opciones(_ sender: AnyObject) {
        let alert = SCLAlertView()
        
        alert.addButton("Leer valoraciones", target:self, selector:Selector("leerOpiniones"))
        alert.addButton("Valorar libro", target:self, selector:Selector("nuevaOpinion"))
        
        if(en_biblioteca==0) // Esta en bibliotecaç?
        {
            alert.addButton("Añadir a biblioteca", target:self, selector:Selector("anadirBiblioteca"))
        }
        else
        {
             alert.addButton("Eliminar de biblioteca", target:self, selector:Selector("anadirBiblioteca"))
        }
        
        if(deseado==0) //esta en deseados?
        {
            alert.addButton("Añadir a deseados", target:self, selector:Selector("anadirDeseados"))
        }
        else
        {
            alert.addButton("Eliminar de deseados", target:self, selector:Selector("anadirDeseados"))
        }
        
        if(en_cambio==0){ //esta para cambiar?
            alert.addButton("Trotar el libro", target:self, selector:Selector("trotarLibro"))
        }
        else
        {
            alert.addButton("Dejar de trotarlo", target:self, selector:Selector("eliminarTrotarLibro"))
        }

       
        alert.showInfo("", subTitle: "¿Qué quieres hacer?",closeButtonTitle:"Cerrar")
    }
 
    
    //cambiamos de pantalla
    func trotarLibro() {
        self.performSegue(withIdentifier: "goToTrotar", sender: self)
    }
    
    //dejamos de trotar un libro, se cancelan todas las permutas abiertas con éste libro
    func eliminarTrotarLibro()
    {
        let prefs:UserDefaults = UserDefaults.standard
        var id_usuario=prefs.string(forKey: "IDUSUARIO")! as String
        var post:NSString = "id_libro=\(id_libro)&id_usuario=\(id_usuario)" as NSString
        
        var ruta = Utils.agafaRuta(string: "no_trotar_libro.php")
        let url:NSURL = NSURL(string: ruta as String)!
        
        let postData:NSData = post.data(using: String.Encoding.utf8.rawValue)! as NSData
        
        let postLength:NSString = String( postData.length ) as NSString
        
        let request:NSMutableURLRequest = NSMutableURLRequest(url: (url as NSURL) as URL)
        request.httpMethod = "POST"
        request.httpBody = postData as Data
        request.setValue(postLength as String, forHTTPHeaderField: "Content-Length")
        request.setValue("application/x-www-form-urlencoded", forHTTPHeaderField: "Content-Type")
        request.setValue("application/json", forHTTPHeaderField: "Accept")
        
        var reponseError: NSError?
        var response: URLResponse?
        
        var urlData: NSData?
        do {
            urlData = try NSURLConnection.sendSynchronousRequest(request as URLRequest, returning:&response) as NSData?
        } catch var error as NSError {
            reponseError = error
            urlData = nil
        }
        
        if ( urlData != nil ) {
            let res = response as! HTTPURLResponse!;
            
            var responseData:NSString  = NSString(data:urlData! as Data, encoding:String.Encoding.utf8.rawValue)!
            
            if ((res?.statusCode)! >= 200 && (res?.statusCode)! < 300)
            {
                var responseData:NSString  = NSString(data:urlData! as Data, encoding:String.Encoding.utf8.rawValue)!
                
                var error: NSError?
                
                let jsonData:NSDictionary = (try! JSONSerialization.jsonObject(with: urlData! as Data, options:JSONSerialization.ReadingOptions.mutableContainers )) as! NSDictionary
                
                let success:NSInteger = jsonData.value(forKey: "success") as! NSInteger
            
                if(success == 1)
                {
                   SCLAlertView().showSuccess("", subTitle:"'Has dejado de trotar el libro!", closeButtonTitle:"Cerrar")
                    en_cambio = 0
                }
                else
                {
                    var error_msg:NSString
                        
                    if jsonData["error_message"] as? NSString != nil
                    {
                            error_msg = jsonData["error_message"] as! NSString
                    }
                    else
                    {
                            error_msg = "Unknown Error"
                    }
                        SCLAlertView().showError("Error", subTitle:error_msg as String, closeButtonTitle:"Cerrar")
                }
                
            } else {
                SCLAlertView().showError("Error", subTitle:"La connexión falló", closeButtonTitle:"Cerrar")
                
            }
        } else {
            SCLAlertView().showError("Error", subTitle:"La connexión falló2", closeButtonTitle:"Cerrar")
            
        }
    }
    
   //Añadimos/eliminamos el libro a la biblioteca del usuario
   func anadirBiblioteca() {
        let prefs:UserDefaults = UserDefaults.standard
        var id_usuario=prefs.string(forKey: "IDUSUARIO")! as String
        var post:NSString = "id_libro=\(id_libro)&id_usuario=\(id_usuario)" as NSString
        
        var ruta = Utils.agafaRuta(string: "anadir_a_biblioteca.php")
        let url:NSURL = NSURL(string: ruta as String)!
        
        let postData:NSData = post.data(using: String.Encoding.ascii.rawValue)! as NSData
    
        let postLength:NSString = String( postData.length ) as NSString
        
        let request:NSMutableURLRequest = NSMutableURLRequest(url: (url as NSURL) as URL)
        request.httpMethod = "POST"
        request.httpBody = postData as Data
        request.setValue(postLength as String, forHTTPHeaderField: "Content-Length")
        request.setValue("application/x-www-form-urlencoded", forHTTPHeaderField: "Content-Type")
        request.setValue("application/json", forHTTPHeaderField: "Accept")
    
        var reponseError: NSError?
        var response: URLResponse?
        
        var urlData: NSData?
        do {
            urlData = try NSURLConnection.sendSynchronousRequest(request as URLRequest, returning:&response) as NSData?
        } catch var error as NSError {
            reponseError = error
            urlData = nil
        }
        
        if ( urlData != nil ) {
            let res = response as! HTTPURLResponse!;
            
            var responseData:NSString  = NSString(data:urlData! as Data, encoding:String.Encoding.utf8.rawValue)!
            
            if ((res?.statusCode)! >= 200 && (res?.statusCode)! < 300)
            {
                var responseData:NSString  = NSString(data:urlData! as Data, encoding:String.Encoding.utf8.rawValue)!
                
                var error: NSError?
                
                let jsonData:NSDictionary = (try! JSONSerialization.jsonObject(with: urlData! as Data, options:JSONSerialization.ReadingOptions.mutableContainers )) as! NSDictionary
                
                let success:NSInteger = jsonData.value(forKey: "success") as! NSInteger
                
                if(success == 2)
                {
                  SCLAlertView().showSuccess("", subTitle:"Lo has añadido a tu biblioteca", closeButtonTitle:"Aceptar")
                   en_biblioteca = 1
                }
                else{
                    if(success == 1)
                    {
                        SCLAlertView().showSuccess("", subTitle:"Lo has eliminado de tu biblioteca", closeButtonTitle:"Aceptar")
                       en_biblioteca = 0
                    }
                    else
                    {
                        var error_msg:NSString
                        
                        if jsonData["error_message"] as? NSString != nil {
                            error_msg = jsonData["error_message"] as! NSString
                        } else {
                            error_msg = "Unknown Error"
                        }
                        SCLAlertView().showError("Error", subTitle:error_msg as String, closeButtonTitle:"Cerrar")
                    }
                }

            } else {
                SCLAlertView().showError("Error", subTitle:"La connexión falló", closeButtonTitle:"Cerrar")
                
            }
        } else {
            SCLAlertView().showError("Error", subTitle:"La connexión falló2", closeButtonTitle:"Cerrar")
            
        }
        
    }
    
    //Añadimos el libro a la lista de deseados
    func anadirDeseados() {
        let prefs:UserDefaults = UserDefaults.standard
        var id_usuario=prefs.string(forKey: "IDUSUARIO")! as String
        var post:NSString = "id_libro=\(id_libro)&id_usuario=\(id_usuario)" as NSString
        
        var ruta = Utils.agafaRuta(string: "anadir_a_deseados.php")
        let url:NSURL = NSURL(string: ruta as String)!
        
        let postData:NSData = post.data(using: String.Encoding.ascii.rawValue)! as NSData
        
        let postLength:NSString = String( postData.length ) as NSString
        
        let request:NSMutableURLRequest = NSMutableURLRequest(url: (url as NSURL) as URL)
        request.httpMethod = "POST"
        request.httpBody = postData as Data
        request.setValue(postLength as String, forHTTPHeaderField: "Content-Length")
        request.setValue("application/x-www-form-urlencoded", forHTTPHeaderField: "Content-Type")
        request.setValue("application/json", forHTTPHeaderField: "Accept")
        
        var reponseError: NSError?
        var response: URLResponse?
        
        var urlData: NSData?
        do {
            urlData = try NSURLConnection.sendSynchronousRequest(request as URLRequest, returning:&response) as NSData?
        } catch var error as NSError {
            reponseError = error
            urlData = nil
        }
        
        if ( urlData != nil ) {
            let res = response as! HTTPURLResponse!;
            
            var responseData:NSString  = NSString(data:urlData! as Data, encoding:String.Encoding.utf8.rawValue)!
            
            if ((res?.statusCode)! >= 200 && (res?.statusCode)! < 300)
            {
                var responseData:NSString  = NSString(data:urlData! as Data, encoding:String.Encoding.utf8.rawValue)!
                
                var error: NSError?
                
                let jsonData:NSDictionary = (try! JSONSerialization.jsonObject(with: urlData! as Data, options:JSONSerialization.ReadingOptions.mutableContainers )) as! NSDictionary
                
                let success:NSInteger = jsonData.value(forKey: "success") as! NSInteger
                
                if(success == 2)
                {
                    SCLAlertView().showSuccess("", subTitle:"Lo has añadido a deseados", closeButtonTitle:"Aceptar")
                    deseado = 1
                }
                else{
                    if(success == 1)
                    {
                        SCLAlertView().showSuccess("", subTitle:"Lo has eliminado de deseados", closeButtonTitle:"Aceptar")
                        deseado = 0
                    }
                    else
                    {
                        var error_msg:NSString
                        
                        if jsonData["error_message"] as? NSString != nil {
                            error_msg = jsonData["error_message"] as! NSString
                        } else {
                            error_msg = "Unknown Error"
                        }
                        SCLAlertView().showError("Error", subTitle:error_msg as String, closeButtonTitle:"Cerrar")
                    }
                }
                
            } else {
                SCLAlertView().showError("Error", subTitle:"La connexión falló", closeButtonTitle:"Cerrar")
                
            }
        } else {
            SCLAlertView().showError("Error", subTitle:"La connexión falló2", closeButtonTitle:"Cerrar")
            
        }
        
    }
    
    
    //Obtenemos los datos del libro
    func obtenerDatos(){
        let prefs:UserDefaults = UserDefaults.standard
        var id_usuario=prefs.string(forKey: "IDUSUARIO")! as String
        var post:NSString = "id_libro=\(id_libro)&id_usuario=\(id_usuario)" as NSString
        
        var ruta = Utils.agafaRuta(string: "coge_libro.php")
        let url:NSURL = NSURL(string: ruta as String)!
        
        let postData:NSData = post.data(using: String.Encoding.ascii.rawValue)! as NSData
        
        let postLength:NSString = String( postData.length ) as NSString
        
        let request:NSMutableURLRequest = NSMutableURLRequest(url: (url as NSURL) as URL)
        request.httpMethod = "POST"
        request.httpBody = postData as Data
        request.setValue(postLength as String, forHTTPHeaderField: "Content-Length")
        request.setValue("application/x-www-form-urlencoded", forHTTPHeaderField: "Content-Type")
        request.setValue("application/json", forHTTPHeaderField: "Accept")
        
        
        var reponseError: NSError?
        var response: URLResponse?
        
        var urlData: NSData?
        do {
            urlData = try NSURLConnection.sendSynchronousRequest(request as URLRequest, returning:&response) as NSData?
        } catch var error as NSError {
            reponseError = error
            urlData = nil
        }
        
        if ( urlData != nil ) {
            let res = response as! HTTPURLResponse!;
            
            var responseData:NSString  = NSString(data:urlData! as Data, encoding:String.Encoding.utf8.rawValue)!
            
            NSLog("Response ==> %@", responseData);
            
            if ((res?.statusCode)! >= 200 && (res?.statusCode)! < 300)
            {
                var responseData:NSString  = NSString(data:urlData! as Data, encoding:String.Encoding.utf8.rawValue)!
                
                var error: NSError?
                
                let jsonData:NSDictionary = (try! JSONSerialization.jsonObject(with: urlData! as Data, options:JSONSerialization.ReadingOptions.mutableContainers )) as! NSDictionary
                
                let success:NSInteger = jsonData.value(forKey: "success") as! NSInteger
                
                //Si ok rellenmaos las variables con los datos descodificados
                if(success == 1)
                {
                    let titulo:NSString = jsonData.value(forKey: "titulo") as! NSString
                    let isbn:NSString = jsonData.value(forKey: "isbn") as! NSString
                    let autor:NSString = jsonData.value(forKey: "autor") as! NSString
                    let genero:NSString = jsonData.value(forKey: "genero") as! NSString
                    let nota:NSString = jsonData.value(forKey: "nota") as! NSString
                    en_biblioteca = jsonData.value(forKey: "en_biblioteca") as! NSInteger
                    deseado = jsonData.value(forKey: "deseado") as! NSInteger
                    portada = jsonData.value(forKey: "portada") as! NSString
                    opinionUsuario = jsonData.value(forKey: "opinionUsuario") as! NSString
                    notaUsuario = jsonData.value(forKey: "notaUsuario") as! NSString
                    en_cambio = jsonData.value(forKey: "en_cambio") as! NSInteger

                    //Si tiene portada descodificamos la imagen y se muestra
                    if(portada != "-"){
                        let decodedData = NSData(base64Encoded: portada as String, options: NSData.Base64DecodingOptions(rawValue: 0))
                        self.portadaImagen.contentMode = UIViewContentMode.scaleToFill
                        self.portadaImagen.image = UIImage(data: decodedData! as Data)
                    }
                    
                    tituloLabel.text = titulo as String
                    isbnLabel.text = isbn as String
                    autorLabel.text = autor as String
                    generoLabel.text = genero as String
                    calificacionButton.setTitle(nota as String, for: UIControlState.normal)

                } else {
                    var error_msg:NSString
                    
                    if jsonData["error_message"] as? NSString != nil {
                        error_msg = jsonData["error_message"] as! NSString
                    } else {
                        error_msg = "Unknown Error"
                    }
                    SCLAlertView().showError("Error", subTitle:error_msg as String, closeButtonTitle:"Cerrar")
                }
                
            } else {
                SCLAlertView().showError("Error", subTitle:"La connexión falló", closeButtonTitle:"Cerrar")
                
            }
        } else {
            SCLAlertView().showError("Error", subTitle:"La connexión falló2", closeButtonTitle:"Cerrar")
            
        }
    }
    
   

    override func didReceiveMemoryWarning()
    {
        super.didReceiveMemoryWarning()
    }
    
    //Función que se ejecuta al cargar la pantalla la primera vez
    override func viewDidLoad()
    {
        super.viewDidLoad()
        self.title = "Detalle libro"
        if(flag==0){ // escondemos el botón de regresar
            let backButton = UIBarButtonItem(title: "", style: UIBarButtonItemStyle.plain, target: navigationController, action: nil)
            navigationItem.leftBarButtonItem = backButton
        }
        obtenerDatos()
    }
    
    override func viewWillDisappear(_ animated : Bool) {
        super.viewWillDisappear(animated)
    }
    
    //FUnción que se ejecuta al regresar a la pantalla
    override func viewWillAppear(_ animated: Bool)
    {
        super.viewWillAppear(animated)
         obtenerDatos()
    }
    
    //preparamos el cambio de pantalla
    override func prepare(for segue: UIStoryboardSegue, sender: Any?) {
        if segue.identifier == "goToOpiniones" {
            let vc = segue.destination as! OpinionesController
            vc.id_libro=id_libro
            vc.portada=portada
        }
        if segue.identifier == "goToNuevaOpinion" {
            let vc = segue.destination as! EntrarOpinionController
            vc.id_libro=id_libro
            vc.nota = notaUsuario
            vc.opinion = opinionUsuario
        }
        if segue.identifier == "goToTrotar" {
            let vc = segue.destination as! TrotarLibroController
            vc.id_libro=id_libro
        }
    }

    
    
}
