//
//  RegistroController.swift
//  trotalibros
//
//  Created by EDU on 5/11/16.
//  Copyright © 2016 EDU. All rights reserved.
//
//
// Clase para identificar un usuario


import UIKit
import QuartzCore

class LoginController: UIViewController,  UITextFieldDelegate {

   //variables conectadas con los elementos de la pantalla
    @IBOutlet weak var emailField:   UITextField!
    @IBOutlet weak var passwordField:   UITextField!
    @IBOutlet weak var loginButton:     UIButton!
    
    
    // Función connectada con un botón de la pantalla. Se envian los datos al servidor por POST
    @IBAction func login(_ sender: AnyObject) {
        
        if (emailField.text!.isEmpty || passwordField.text!.isEmpty){
           SCLAlertView().showWarning("ATENCIÓN", subTitle: "Todos los campos son obligatorios",closeButtonTitle:"OK")
        }
        else{
            
            var post:NSString = "email=\(emailField.text!)&password=\(passwordField.text!)" as NSString
            
            var ruta = Utils.agafaRuta(string: "login.php")
            let url:NSURL = NSURL(string: ruta as String)!
            
            let postData:NSData = post.data(using: String.Encoding.ascii.rawValue)! as NSData
            
            let postLength:NSString = String( postData.length ) as NSString
            
            let request:NSMutableURLRequest = NSMutableURLRequest(url: (url as NSURL) as URL)
            request.httpMethod = "POST"
            request.httpBody = postData as Data
            request.setValue(postLength as String, forHTTPHeaderField: "Content-Length")
            request.setValue("application/x-www-form-urlencoded", forHTTPHeaderField: "Content-Type")
            request.setValue("application/json", forHTTPHeaderField: "Accept")
            
            
            var reponseError: NSError?
            var response: URLResponse?
            
            var urlData: NSData?
            do {
                urlData = try NSURLConnection.sendSynchronousRequest(request as URLRequest, returning:&response) as NSData?
            } catch var error as NSError {
                reponseError = error
                urlData = nil
            }
            
            if ( urlData != nil ) {
                let res = response as! HTTPURLResponse!;
                
                NSLog("Response code: %ld", String(describing: res?.statusCode));
                var responseData:NSString  = NSString(data:urlData! as Data, encoding:String.Encoding.utf8.rawValue)!
                
                if ((res?.statusCode)! >= 200 && (res?.statusCode)! < 300)
                {
                    var responseData:NSString  = NSString(data:urlData! as Data, encoding:String.Encoding.utf8.rawValue)!
                    
                    NSLog("Response ==> %@", responseData);
                    
                    var error: NSError?
                    
                    let jsonData:NSDictionary = (try! JSONSerialization.jsonObject(with: urlData! as Data, options:JSONSerialization.ReadingOptions.mutableContainers )) as! NSDictionary
                    
                    let success:NSInteger = jsonData.value(forKey: "success") as! NSInteger
                    
                    //Identificació OK
                    if(success == 1)
                    {
                        //Llegim la variable JSON
                        let id_usuari:NSInteger = jsonData.value(forKey: "id_usuari") as! NSInteger
                        let nom:NSString = jsonData.value(forKey: "nom") as! NSString
                       
                        //Guardem les dades de l'usauri identificat per utilitzar-les en qualsevol classe
                        let prefs:UserDefaults = UserDefaults.standard
                        prefs.set(id_usuari, forKey: "IDUSUARIO")
                        prefs.set(nom, forKey: "NOMBRE")
                        prefs.set(1, forKey: "ISLOGGEDIN")
                        prefs.synchronize()
                        
                        //es canvia de pantalla
                        self.performSegue(withIdentifier: "goto_home", sender: self)                        
                    }
                    else
                    {
                        var error_msg:NSString
                        
                        if jsonData["error_message"] as? NSString != nil {
                            error_msg = jsonData["error_message"] as! NSString
                        } else {
                            error_msg = "Unknown Error"
                        }
                        SCLAlertView().showError("Error", subTitle:error_msg as String, closeButtonTitle:"Cerrar")
                    }
                    
                } else {
                    SCLAlertView().showError("Error", subTitle:"La connexión falló", closeButtonTitle:"Cerrar")

                }
            } else {
                SCLAlertView().showError("Error", subTitle:"La connexión falló2", closeButtonTitle:"Cerrar")

            }

        }
    }
    
     //Escondemos el teclado
    func textFieldShouldReturn(textField: UITextField) -> Bool {
        emailField.resignFirstResponder()
        passwordField.resignFirstResponder()
        return true;
    }
    
    //Escondemos el teclado al tocar el fondo de pantalla
   override func touchesBegan(_ touches: Set<UITouch>, with event: UIEvent?) {
        emailField.resignFirstResponder()
        passwordField.resignFirstResponder()
        self.view.endEditing(true)
    }
    
    override func viewDidLoad() {
        super.viewDidLoad()
    }
    
    override func didReceiveMemoryWarning() {
        super.didReceiveMemoryWarning()
    }
}





