//
//  PermutaDetalleController.swift
//  trotalibros
//
//  Created by EDU on 4/12/16.
//  Copyright © 2016 EDU. All rights reserved.
//  Clase para visualizar una permuta y decidir si aceptarla, cancelarla o valorarla


import UIKit
import QuartzCore

class PermutaDetalleController: UIViewController {
    
    //variables conectadas con los elementos de la pantalla
    @IBOutlet weak var usuarioLabel: UILabel!
    @IBOutlet weak var tituloPides: UILabel!
    @IBOutlet weak var tituloOfreces: UILabel!
    @IBOutlet weak var comentarioText: UITextView!
    @IBOutlet weak var menuSelector: UISegmentedControl!
    @IBOutlet weak var rechazarButon: UIButton!
    @IBOutlet weak var aceptarButton: UIButton!
    @IBOutlet weak var separador2: UILabel!
    @IBOutlet weak var separador1: UILabel!
    @IBOutlet weak var respuestaText: UITextView!
    @IBOutlet weak var label: UILabel!
    @IBOutlet weak var valoracionButton: UIButton!
    
    
    //variables internas
    var id_permuta: Int = 0
    var id_libro_receptor: Int = 0
    var id_libro_emisor: Int = 0
    var id_usuario_emisor: Int = 0
    var id_usuario_receptor: Int = 0
    var estado: Int = 0
    var tipo: Int = 0
    var observacion:NSString = ""
    var imagen:NSString = ""
    var respuesta:NSString = ""
    var nombre_receptor:NSString = ""
    var nombre_emisor:NSString = ""
    var valorada:Int = 0
    var comentario_valoracion:NSString = ""
    var puntuacion:NSString = ""
    
    
    //Definimos la ación a efectuar segun si la permuta está valorada o no
    @IBAction func valorar(_ sender: AnyObject) {
        if(valorada==0)
        {
            self.performSegue(withIdentifier: "goToValorarPermuta", sender: self)
        }
        else
        {
            self.performSegue(withIdentifier: "goToDetalleValoracion", sender: self)
        }
    }
    
    //Pop up de aviso antes de confirmar la acción
    @IBAction func aceptar(_ sender: AnyObject) {
        let alert = SCLAlertView()
        
        if(tipo == 0) //el usuario es el creador de la permuta y puede cancelarla
        {
            alert.addButton("Cancelar permuta", target:self, selector:Selector("aceptar"))
            alert.showInfo("", subTitle: "¿Seguro que quieres cancelarla?",closeButtonTitle:"Cerrar")
        }
        else //En caso contrario la puede aceptar
        {
            alert.addButton("Aceptar permuta", target:self, selector:Selector("aceptar"))
            alert.showInfo("", subTitle: "¿Seguro que quieres aceptarla? Se enviará tu email a l'usuario para que programéis el cambio.",closeButtonTitle:"Cerrar")
        }
        
    }
    
    //Se definen las acciones del menú
    @IBAction func menu(_ sender: AnyObject) {
   
        switch menuSelector.selectedSegmentIndex
        {
            case 0:
                self.performSegue(withIdentifier: "goToValoraciones2", sender: self)
            case 1:
                 self.performSegue(withIdentifier: "goToEjemplar", sender: self)
            case 2:
               self.performSegue(withIdentifier: "goToLibro8", sender: self)
            default:
                break;
        
        }
    }

    
    //Se acepta la permuta o se cancela si la permuta la ha creado el usuario. Los parámetros se envian por POST
    func aceptar()
    {
        let prefs:UserDefaults = UserDefaults.standard
        var id_usuario=prefs.string(forKey: "IDUSUARIO")! as String
        
        var post:NSString = ""
        if(tipo == 0)
        {
             post = "id_permuta=\(id_permuta)&id_usuario=\(id_usuario)&estado=1&respuesta=\(respuestaText.text!)" as NSString
        }
        else
        {
             post = "id_permuta=\(id_permuta)&id_usuario=\(id_usuario)&estado=2&respuesta=\(respuestaText.text!)" as NSString

        }
        
        var ruta = Utils.agafaRuta(string: "modificar_estado_permuta.php")
        let url:NSURL = NSURL(string: ruta as String)!
        
        let postData:NSData = post.data(using: String.Encoding.ascii.rawValue)! as NSData
        
        let postLength:NSString = String( postData.length ) as NSString
        
        let request:NSMutableURLRequest = NSMutableURLRequest(url: (url as NSURL) as URL)
        request.httpMethod = "POST"
        request.httpBody = postData as Data
        request.setValue(postLength as String, forHTTPHeaderField: "Content-Length")
        request.setValue("application/x-www-form-urlencoded", forHTTPHeaderField: "Content-Type")
        request.setValue("application/json", forHTTPHeaderField: "Accept")
        
        var reponseError: NSError?
        var response: URLResponse?
        
        var urlData: NSData?
        do {
            urlData = try NSURLConnection.sendSynchronousRequest(request as URLRequest, returning:&response) as NSData?
        } catch var error as NSError {
            reponseError = error
            urlData = nil
        }
        
        if ( urlData != nil ) {
            let res = response as! HTTPURLResponse!;
            
            var responseData:NSString  = NSString(data:urlData! as Data, encoding:String.Encoding.utf8.rawValue)!
            
            NSLog("Response ==> %@", responseData);
            
            if ((res?.statusCode)! >= 200 && (res?.statusCode)! < 300)
            {
                var responseData:NSString  = NSString(data:urlData! as Data, encoding:String.Encoding.utf8.rawValue)!
                
                NSLog("Response ==> %@", responseData);
                
                var error: NSError?
                
                let jsonData:NSDictionary = (try! JSONSerialization.jsonObject(with: urlData! as Data, options:JSONSerialization.ReadingOptions.mutableContainers )) as! NSDictionary
                
                let success:NSInteger = jsonData.value(forKey: "success") as! NSInteger
                
                NSLog("Success: %ld", success);
                
                //Si ok recargamos la pantalla
                if(success == 1)
                {
                    viewDidLoad()
                    
                } else {
                    var error_msg:NSString
                    
                    if jsonData["error_message"] as? NSString != nil {
                        error_msg = jsonData["error_message"] as! NSString
                    } else {
                        error_msg = "Unknown Error"
                    }
                    SCLAlertView().showError("Error", subTitle:error_msg as String, closeButtonTitle:"Cerrar")
                }
                
            } else {
                SCLAlertView().showError("Error", subTitle:"La connexión falló", closeButtonTitle:"Cerrar")
                
            }
        } else {
            SCLAlertView().showError("Error", subTitle:"La connexión falló2", closeButtonTitle:"Cerrar")
            
        }

    }
    
    //Se cancela la permuta. Los parámetros se envian por POST
    func rechazar()
    {
        let prefs:UserDefaults = UserDefaults.standard
        var id_usuario=prefs.string(forKey: "IDUSUARIO")! as String
        
        var post:NSString = "id_permuta=\(id_permuta)&id_usuario=\(id_usuario)&estado=1&respuesta=\(respuestaText.text!)" as NSString
        
        var ruta = Utils.agafaRuta(string: "modificar_estado_permuta.php")
        let url:NSURL = NSURL(string: ruta as String)!
        
        let postData:NSData = post.data(using: String.Encoding.ascii.rawValue)! as NSData
        
        let postLength:NSString = String( postData.length ) as NSString
        
        let request:NSMutableURLRequest = NSMutableURLRequest(url: (url as NSURL) as URL)
        request.httpMethod = "POST"
        request.httpBody = postData as Data
        request.setValue(postLength as String, forHTTPHeaderField: "Content-Length")
        request.setValue("application/x-www-form-urlencoded", forHTTPHeaderField: "Content-Type")
        request.setValue("application/json", forHTTPHeaderField: "Accept")
        
        var reponseError: NSError?
        var response: URLResponse?
        
        var urlData: NSData?
        do {
            urlData = try NSURLConnection.sendSynchronousRequest(request as URLRequest, returning:&response) as NSData?
        } catch var error as NSError {
            reponseError = error
            urlData = nil
        }
        
        if ( urlData != nil ) {
            let res = response as! HTTPURLResponse!;
            
            var responseData:NSString  = NSString(data:urlData! as Data, encoding:String.Encoding.utf8.rawValue)!
            

            
            if ((res?.statusCode)! >= 200 && (res?.statusCode)! < 300)
            {
                var responseData:NSString  = NSString(data:urlData! as Data, encoding:String.Encoding.utf8.rawValue)!
                
  
                
                var error: NSError?
                
                let jsonData:NSDictionary = (try! JSONSerialization.jsonObject(with: urlData! as Data, options:JSONSerialization.ReadingOptions.mutableContainers )) as! NSDictionary
                
                let success:NSInteger = jsonData.value(forKey: "success") as! NSInteger
                
                //Si ok recargamos la pantalla
                if(success == 1)
                {
                    viewDidLoad()
                    
                } else {
                    var error_msg:NSString
                    
                    if jsonData["error_message"] as? NSString != nil {
                        error_msg = jsonData["error_message"] as! NSString
                    } else {
                        error_msg = "Unknown Error"
                    }
                    SCLAlertView().showError("Error", subTitle:error_msg as String, closeButtonTitle:"Cerrar")
                }
                
            } else {
                SCLAlertView().showError("Error", subTitle:"La connexión falló", closeButtonTitle:"Cerrar")
                
            }
        } else {
            SCLAlertView().showError("Error", subTitle:"La connexión falló2", closeButtonTitle:"Cerrar")
            
        }
    }
    
    //Función de confirmnación para cancelar una permuta
    @IBAction func rechazar(_ sender: AnyObject) {
        let alert = SCLAlertView()
        alert.addButton("Rechazar permuta", target:self, selector:Selector("aceptar"))
        alert.showInfo("", subTitle: "¿Seguro que quieres rechazarla?",closeButtonTitle:"Cerrar")
    }
    
    func obtenerDatos(){
        let prefs:UserDefaults = UserDefaults.standard
        var id_usuario=prefs.string(forKey: "IDUSUARIO")! as String
        var post:NSString = "id_permuta=\(id_permuta)&id_usuario=\(id_usuario)" as NSString
        
        var ruta = Utils.agafaRuta(string: "detalle_permuta.php")
        let url:NSURL = NSURL(string: ruta as String)!
        
        let postData:NSData = post.data(using: String.Encoding.utf8.rawValue)! as NSData
        
        let postLength:NSString = String( postData.length ) as NSString
        
        let request:NSMutableURLRequest = NSMutableURLRequest(url: (url as NSURL) as URL)
        request.httpMethod = "POST"
        request.httpBody = postData as Data
        request.setValue(postLength as String, forHTTPHeaderField: "Content-Length")
        request.setValue("application/x-www-form-urlencoded", forHTTPHeaderField: "Content-Type")
        request.setValue("application/json", forHTTPHeaderField: "Accept")
        
        
        var reponseError: NSError?
        var response: URLResponse?
        
        var urlData: NSData?
        do {
            urlData = try NSURLConnection.sendSynchronousRequest(request as URLRequest, returning:&response) as NSData?
        } catch var error as NSError {
            reponseError = error
            urlData = nil
        }
        
        if ( urlData != nil ) {
            let res = response as! HTTPURLResponse!;
            
            var responseData:NSString  = NSString(data:urlData! as Data, encoding:String.Encoding.utf8.rawValue)!
            
            NSLog("Response ==> %@", responseData);
            
            if ((res?.statusCode)! >= 200 && (res?.statusCode)! < 300)
            {
                var responseData:NSString  = NSString(data:urlData! as Data, encoding:String.Encoding.utf8.rawValue)!
                
                NSLog("Response ==> %@", responseData);
                
                var error: NSError?
                
                let jsonData:NSDictionary = (try! JSONSerialization.jsonObject(with: urlData! as Data, options:JSONSerialization.ReadingOptions.mutableContainers )) as! NSDictionary
                
                let success:NSInteger = jsonData.value(forKey: "success") as! NSInteger
                
                NSLog("Success: %ld", success);
                
                // Si ok obtenemos todos los datos de la permuta en formato json y lo descodificamos
                if(success == 1)
                {
                    
                     tipo = jsonData.value(forKey: "tipo") as! NSInteger
               
                    if(tipo == 0) //permuta hecha por el usuario
                    {
                      nombre_receptor = jsonData.value(forKey: "nombre_receptor") as! NSString
                      let titulo_receptor:NSString = jsonData.value(forKey: "titulo_receptor") as! NSString
                      let titulo_emisor:NSString = jsonData.value(forKey: "titulo_emisor") as! NSString
                      id_libro_receptor = jsonData.value(forKey: "id_libro_receptor") as! NSInteger
                      id_libro_emisor = jsonData.value(forKey: "id_libro_emisor") as! NSInteger
                      id_usuario_emisor = jsonData.value(forKey: "id_usuario_emisor") as! NSInteger
                      id_usuario_receptor = jsonData.value(forKey: "id_usuario_receptor") as! NSInteger
                      let comentario_emisor:NSString = jsonData.value(forKey: "comentario_emisor") as! NSString
                      estado = jsonData.value(forKey: "estado") as! NSInteger
                      observacion = jsonData.value(forKey: "observacion") as! NSString
                      imagen = jsonData.value(forKey: "imagen") as! NSString
                      respuesta = jsonData.value(forKey: "respuesta") as! NSString
                      valorada = jsonData.value(forKey: "valorada") as! NSInteger
                      puntuacion = jsonData.value(forKey: "puntuacion") as! NSString
                      comentario_valoracion = jsonData.value(forKey: "comentario_valoracion") as! NSString
                        
                      usuarioLabel.text = "Tu permuta con " + (nombre_receptor as String)
                      tituloPides.text = titulo_receptor as String
                      tituloOfreces.text = titulo_emisor as String
                      comentarioText.text = "Tú has dicho: " + (comentario_emisor as String) as String
                      separador1.text = "Pides"
                      separador2.text = "Ofreces"
                    }
                    else
                    {
                        if(tipo == 1) //permuta hecha al usuario
                        {
                            nombre_emisor = jsonData.value(forKey: "nombre_emisor") as! NSString
                            let titulo_receptor:NSString = jsonData.value(forKey: "titulo_receptor") as! NSString
                            let titulo_emisor:NSString = jsonData.value(forKey: "titulo_emisor") as! NSString
                            id_libro_receptor = jsonData.value(forKey: "id_libro_receptor") as! NSInteger
                            id_libro_emisor = jsonData.value(forKey: "id_libro_emisor") as! NSInteger
                            id_usuario_emisor = jsonData.value(forKey: "id_usuario_emisor") as! NSInteger
                            id_usuario_receptor = jsonData.value(forKey: "id_usuario_receptor") as! NSInteger
                            let comentario_emisor:NSString = jsonData.value(forKey: "comentario_emisor") as! NSString
                            estado = jsonData.value(forKey: "estado") as! NSInteger
                            observacion = jsonData.value(forKey: "observacion") as! NSString
                            imagen = jsonData.value(forKey: "imagen") as! NSString
                            respuesta = jsonData.value(forKey: "respuesta") as! NSString
                            valorada = jsonData.value(forKey: "valorada") as! NSInteger
                            puntuacion = jsonData.value(forKey: "puntuacion") as! NSString
                            comentario_valoracion = jsonData.value(forKey: "comentario_valoracion") as! NSString

                            usuarioLabel.text = "Tu permuta con " + (nombre_emisor as String)
                            tituloPides.text = titulo_emisor as String
                            tituloOfreces.text = titulo_receptor as String
                            comentarioText.text = (nombre_emisor as String) + " te ha dicho: " + (comentario_emisor as String) as String
                            separador1.text = "Te ofrecen"
                            separador2.text = "Te piden"
                        }
                    }

                    
                } else {
                    var error_msg:NSString
                    
                    if jsonData["error_message"] as? NSString != nil {
                        error_msg = jsonData["error_message"] as! NSString
                    } else {
                        error_msg = "Unknown Error"
                    }
                    SCLAlertView().showError("Error", subTitle:error_msg as String, closeButtonTitle:"Cerrar")
                }
                
            } else {
                SCLAlertView().showError("Error", subTitle:"La connexión falló", closeButtonTitle:"Cerrar")
                
            }
        } else {
            SCLAlertView().showError("Error", subTitle:"La connexión falló2", closeButtonTitle:"Cerrar")
            
        }
    }
    
    //Función al cargar la pantalla la primera vez. Mostramos o escondemos elementos según la permuta y el usuario
    override func viewDidLoad()
    {
        super.viewDidLoad()
        self.title = "Permuta"
        obtenerDatos()
        
        if(valorada==0) // Si no está valorada, valoramos
        {
          valoracionButton.setTitle("Valora la permuta", for: .normal)
        }
        else // Si está cvalorada miramos la valoración
        {
            valoracionButton.setTitle("Valoración", for: .normal)
        }
        
        if(estado == 1 || estado == 2) //estado aceptado o rechazado
        {
            rechazarButon.isHidden = true
            aceptarButton.isHidden = true
            
            if(estado == 2) //estado aceptado
            {
               valoracionButton.isHidden = false
            }
            
            if(tipo == 0) //el usuario es el emisor
            {
                respuestaText.text = (nombre_receptor as String) + " te ha dicho: " + (respuesta as String) as String
            }
            else
            {
               respuestaText.text = "Tú has dicho: " + (respuesta as String) as String
            }
            respuestaText.isEditable = false
            label.isHidden = true
        }
        else
        {
            if(tipo == 0) //el usuario es el emisor
            {
                aceptarButton.setTitle("Cancelar", for: .normal)
                rechazarButon.isHidden = true
                respuestaText.isHidden = true
                label.isHidden = true
            }
        }
    }
    
    
    //Funcion que prepara los enlaces de cambio de pantalla con sus respectivos parámetros
    override func prepare(for segue: UIStoryboardSegue, sender: Any?) {
        
        
        if segue.identifier == "goToLibro8" {
            let vc = segue.destination as! LibroController
            
            if(tipo == 0)
            {
                vc.id_libro = id_libro_receptor
            }
            else
            {
                vc.id_libro = id_libro_emisor
            }
            
            vc.flag = 1
        }
        
        if segue.identifier == "goToValoraciones2" {
            let vc = segue.destination as! ValoracionesController
            
            if(tipo == 0)
            {
                vc.id_usuario = id_usuario_receptor
            }
            else
            {
                vc.id_usuario = id_usuario_emisor
            }
        }
        
        if segue.identifier == "goToEjemplar" {
            let vc = segue.destination as! InfoLibroCambioController
            vc.imagen = imagen
            vc.observacion = observacion
        }
        
        if segue.identifier == "goToValorarPermuta" {
            let vc = segue.destination as! HacerValoracionController
            vc.id_permuta = id_permuta
            if(tipo == 0)
            {
                vc.id_usuario_valorado = id_usuario_receptor
                vc.nombre_usuario_valorado = nombre_receptor
            }
            else
            {
                vc.id_usuario_valorado = id_usuario_emisor
                vc.nombre_usuario_valorado = nombre_emisor
            }
            
        }
        if segue.identifier == "goToDetalleValoracion" {
            let vc = segue.destination as! DetalleValoracionController
            if(tipo == 0)
            {
                vc.nombre_usuario_valorado = nombre_receptor
            }
            else
            {
                vc.nombre_usuario_valorado = nombre_emisor
            }
            vc.puntuacion = puntuacion
            vc.opinion = comentario_valoracion
            
        }
        
    }
    
    override func viewWillDisappear(_ animated : Bool) {
        super.viewWillDisappear(animated)
    }
    
    //Función que se ejecuta al regresar a la pantalla
    override func viewWillAppear(_ animated: Bool)
    {
        super.viewWillAppear(animated)
        self.menuSelector.selectedSegmentIndex = UISegmentedControlNoSegment
    }
    
    override func didReceiveMemoryWarning() {
        super.didReceiveMemoryWarning()
    }
    
    //Escondemos el teclado
    func textFieldShouldReturn(textField: UITextField) -> Bool {
        respuestaText.resignFirstResponder()
        return true;
    }
    
    //Escodenmos el teclado al tocar el fondo de pantalla
    override func touchesBegan(_ touches: Set<UITouch>, with event: UIEvent?) {
        respuestaText.resignFirstResponder()
        self.view.endEditing(true)
    }

    
    
}
