//
//  RegistroController.swift
//  trotalibros
//
//  Created by EDU on 5/11/16.
//  Copyright © 2016 EDU. All rights reserved.
//
//
//  Clase per crear un usuario


import Foundation
import UIKit

class RegistreController: UIViewController,  UITextFieldDelegate {
    
    //variables conectadas con los elementos de la pantalla
    @IBOutlet weak var nomText: UITextField!
    @IBOutlet weak var emailText: UITextField!
    @IBOutlet weak var passText: UITextField!
    @IBOutlet weak var pass2Text: UITextField!
    
    
    //variables internea
    var success = 0
    var error_msg = ""
    var message = ""
    
    
    // Función connectada con un botón de la pantalla. Se envian los datos al servidor por POST
    
      @IBAction func registre(_ sender: AnyObject) {

        if(nomText.text!.isEmpty || emailText.text!.isEmpty || passText.text!.isEmpty || pass2Text.text!.isEmpty)
        {
            SCLAlertView().showWarning("ATENCIÓN", subTitle: "Todos los campos son obligatorios",closeButtonTitle:"OK")
        }
        else
        {
            if(passText.text!.characters.count<6){
                SCLAlertView().showWarning("ATENCIÓ", subTitle: "La contraseña deber tener mínimo 6 carácteres",closeButtonTitle:"OK")
            }
            else
            {
                if(passText.text != pass2Text.text){
                    SCLAlertView().showWarning("ATENCIÓ", subTitle: "Las contraseñas son diferentes",closeButtonTitle:"OK")
                }
                else
                {
                    let post:NSString = "nom=\(nomText.text!)&email=\(emailText.text!)&contrasenya=\(passText.text!)&contrasenya2=\(pass2Text.text!)" as NSString
                    
                    
                    let ruta = Utils.agafaRuta(string: "crear_usuario.php")
                    let url:NSURL = NSURL(string: ruta as String)!
                    
                    let postData:NSData = post.data(using: String.Encoding.utf8.rawValue)! as NSData
                    
                    let postLength:NSString = String( postData.length ) as NSString
                    
                    let request:NSMutableURLRequest = NSMutableURLRequest(url: (url as NSURL) as URL)
                    request.httpMethod = "POST"
                    request.httpBody = postData as Data
                    request.setValue(postLength as String, forHTTPHeaderField: "Content-Length")
                    request.setValue("application/x-www-form-urlencoded", forHTTPHeaderField: "Content-Type")
                    request.setValue("application/json", forHTTPHeaderField: "Accept")
                    
                    var reponseError: NSError?
                    var response: URLResponse?
                    
                    var urlData: NSData?
                    do {
                        urlData = try NSURLConnection.sendSynchronousRequest(request as URLRequest, returning:&response) as NSData?
                    } catch var error as NSError {
                        reponseError = error
                        urlData = nil
                    }
                    
                    if ( urlData != nil ) {
                        let res = response as! HTTPURLResponse!;
                        
                        if ((res?.statusCode)! >= 200 && (res?.statusCode)! < 300)
                        {
                            var responseData:NSString  = NSString(data:urlData! as Data, encoding:String.Encoding.utf8.rawValue)!
                            
                            var error: NSError?
                            
                            let jsonData:NSDictionary = (try! JSONSerialization.jsonObject(with: urlData! as Data, options:JSONSerialization.ReadingOptions.mutableContainers )) as! NSDictionary
                            
                            let success:NSInteger = jsonData.value(forKey: "success") as! NSInteger
                            
                            // Registro OK
                            if(success == 1)
                            {
                                let alert = SCLAlertView()
                                alert.addButton("Continuar", target:self, selector:Selector("registreOK"))
                                alert.showSuccess("Bienvenido, "+nomText.text!+"!", subTitle: "Puedes acceder des de la pantalla de login",closeButtonTitle:"Cerrar")
                                nomText.text = ""
                                emailText.text = ""
                                passText.text = ""
                                pass2Text.text = ""
                            }
                            else
                            {
                                var error_msg:NSString
                                
                                if jsonData["error_message"] as? NSString != nil
                                {
                                    error_msg = jsonData["error_message"] as! NSString
                                }
                                else {
                                    error_msg = "Error desconocido"
                                }
                                SCLAlertView().showError("Error", subTitle:error_msg as String, closeButtonTitle:"Cerrar")
                            }
                            
                        }
                        else
                        {
                            SCLAlertView().showError("Error", subTitle:"La connexión falló", closeButtonTitle:"Cerrar")
                        }
                    }
                    else
                    {
                        SCLAlertView().showError("Error", subTitle:"La connexión falló", closeButtonTitle:"Cerrar")
                    }
                }
                
            }
            
        }
        
    }
   
    
    // Cambio de pantalla
    func registreOK(){
        self.performSegue(withIdentifier: "registre_ok", sender: self)
    }
    
    
    //Escondemos el teclado
    func textFieldShouldReturn(textField: UITextField) -> Bool {
        nomText.resignFirstResponder()
        emailText.resignFirstResponder()
        passText.resignFirstResponder()
        pass2Text.resignFirstResponder()
        return true;
    }
    
     //Escondemos el teclado al tocar el fondo de pantalla
    override func touchesBegan(_ touches: Set<UITouch>, with event: UIEvent?) {
        nomText.resignFirstResponder()
        emailText.resignFirstResponder()
        passText.resignFirstResponder()
        pass2Text.resignFirstResponder()
        self.view.endEditing(true)
    }
    
    
    // Funció executada al carregar per primer cop la pantalla
    override func viewDidLoad() {
        super.viewDidLoad()
        self.nomText.delegate = self
        self.emailText.delegate = self
        self.passText.delegate = self
        self.pass2Text.delegate = self
    }
    
    override func didReceiveMemoryWarning() {
        super.didReceiveMemoryWarning()
    }
    
}




