//
//  ResultadoGenerosController.swift
//  trotalibros
//
//  Created by EDU on 26/11/16.
//  Copyright © 2016 EDU. All rights reserved.
//  Clase que muestra en formato tabla los libros de un género

import Foundation
import UIKit
import QuartzCore

class ResultadoGenerosController: UITableViewController {
    
    //variables internas
    var titulos: [String] = []
    var id_libros: [Int] = []
    var isbns: [String] = []
    var portadas: [String] = []
    var autores: [String] = []
    var generos: [String] = []
    var totalLibros : Int = 0
    var id_genero : Int = 0
    var genero = ""
    
    
    //obtenemos los libros de un género en concreto
    func obtenerDatos(){
        
        var post:NSString = "id_genero=\(id_genero)" as NSString
        
        var ruta = Utils.agafaRuta(string: "resultado_genero.php")
        let url:NSURL = NSURL(string: ruta as String)!
        
        let postData:NSData = post.data(using: String.Encoding.utf8.rawValue)! as NSData
        let postLength:NSString = String( postData.length ) as NSString
        let request:NSMutableURLRequest = NSMutableURLRequest(url: (url as NSURL) as URL)
        request.httpMethod = "POST"
        request.httpBody = postData as Data
        request.setValue(postLength as String, forHTTPHeaderField: "Content-Length")
        request.setValue("application/x-www-form-urlencoded", forHTTPHeaderField: "Content-Type")
        request.setValue("application/json", forHTTPHeaderField: "Accept")
        
        
        var reponseError: NSError?
        var response: URLResponse?
        
        var urlData: NSData?
        do {
            urlData = try NSURLConnection.sendSynchronousRequest(request as URLRequest, returning:&response) as NSData?
        } catch var error as NSError {
            reponseError = error
            urlData = nil
        }
        
        if ( urlData != nil ) {
            let res = response as! HTTPURLResponse!;
            
            var responseData:NSString  = NSString(data:urlData! as Data, encoding:String.Encoding.utf8.rawValue)!
            
            NSLog("Response ==> %@", responseData);
            
            if ((res?.statusCode)! >= 200 && (res?.statusCode)! < 300)
            {
                let json = JSON(data: urlData! as Data)
                totalLibros = json.count
                if(json.count>0){
                    for index in 0...(json.count-1)
                    {
                        //guardamos cada libro en arrays, cada una para un parámetro
                        titulos.append((json[index]["titulo"].stringValue as NSString) as String)
                        id_libros.append(json[index]["id_libro"].intValue as Int)
                        isbns.append((json[index]["isbn"].stringValue as NSString) as String)
                        portadas.append((json[index]["portada"].stringValue as NSString) as String)
                        generos.append((json[index]["genero"].stringValue as NSString) as String)
                        autores.append((json[index]["autor"].stringValue as NSString) as String)
                    }
                }
            }
            else
            {
                SCLAlertView().showError("Error", subTitle:"La connexión falló", closeButtonTitle:"Cerrar")
                
            }
        }
        else
        {
            SCLAlertView().showError("Error", subTitle:"La connexión falló2", closeButtonTitle:"Cerrar")
            
        }
    }
    
    
    
    override func tableView(_ tableView: UITableView?, numberOfRowsInSection section: Int) -> Int
    {
        return self.generos.count;
    }
    
    //Rellenamos cada fila de la tabla con un libro. cada elemento de la fila tiene un TAG que lo diferencia
    override func tableView(_ tableView: UITableView, cellForRowAt indexPath: IndexPath) -> UITableViewCell {
        let cell = tableView.dequeueReusableCell(withIdentifier: "resultadoCell", for: indexPath)
        
        if let tituloLabel = cell.viewWithTag(100) as? UILabel
        {
            tituloLabel.text = self.titulos[indexPath.row]
        }
        
        if let autorLabel = cell.viewWithTag(102) as? UILabel
        {
            autorLabel.text = self.autores[indexPath.row]
        }
        
        if let generoLabel = cell.viewWithTag(103) as? UILabel
        {
            generoLabel.text = genero
        }
        
        if(self.portadas[indexPath.row] != "-")
        {
        
            if let ratingImageView = cell.viewWithTag(101) as? UIImageView
            {
                let decodedData = NSData(base64Encoded: self.portadas[indexPath.row] as String, options: NSData.Base64DecodingOptions(rawValue: 0))
                ratingImageView.contentMode = UIViewContentMode.scaleToFill
                ratingImageView.image = UIImage(data: decodedData! as Data)
            }
        }

        
        return cell
    }
    
     //Ponemos un título a la tabla
    override func tableView(_ tableView: UITableView, titleForHeaderInSection section: Int) -> String? {
        return "\(totalLibros) libros encontrados"
    }
    
    
     //Se preparan los parámetros para cambiar de pantalla
    override func prepare(for segue: UIStoryboardSegue, sender: Any?) {
        let index = tableView.indexPathForSelectedRow!
        
        let id_libro = self.id_libros[index.row]
        
        if segue.identifier == "goToLibro3" {
            let vc = segue.destination as! LibroController
            vc.id_libro = id_libro
            vc.flag = 1
        }
    }
    
    override func didReceiveMemoryWarning()
    {
        super.didReceiveMemoryWarning()
    }
    
     //Función que se ejecuta al cargar la pantalla la primera vez
    override func viewDidLoad()
    {
        super.viewDidLoad()
        self.title = genero
        obtenerDatos()
    }
}

