//
//  OpinionesController.swift
//  trotalibros
//
//  Created by Andorsoft on 22/11/16.
//  Copyright © 2016 EDU. All rights reserved.
//  Clase que muestra en formato tabla las opiniones de un libro


import Foundation
import UIKit
import QuartzCore

class ValoracionesController: UITableViewController {
    
    //variables internas
    var id_usuario: Int = 0;
    var puntuaciones: [String] = []
    var valoraciones: [String] = []
    var fechas: [String] = []
    var usuarios: [String] = []
    var totalValoraciones: Int = 0
    
    //Obtenemos todas las opiniones de un libro
    func obtenerDatos(){
        
        var post:NSString = "id_usuario=\(id_usuario)" as NSString
        print(id_usuario)
        
        var ruta = Utils.agafaRuta(string: "coge_valoraciones.php")
        let url:NSURL = NSURL(string: ruta as String)!
        
        let postData:NSData = post.data(using: String.Encoding.utf8.rawValue)! as NSData
        
        let postLength:NSString = String( postData.length ) as NSString
        
        let request:NSMutableURLRequest = NSMutableURLRequest(url: (url as NSURL) as URL)
        request.httpMethod = "POST"
        request.httpBody = postData as Data
        request.setValue(postLength as String, forHTTPHeaderField: "Content-Length")
        request.setValue("application/x-www-form-urlencoded", forHTTPHeaderField: "Content-Type")
        request.setValue("application/json", forHTTPHeaderField: "Accept")        
        
        var reponseError: NSError?
        var response: URLResponse?
        
        var urlData: NSData?
        do {
            urlData = try NSURLConnection.sendSynchronousRequest(request as URLRequest, returning:&response) as NSData?
        } catch var error as NSError {
            reponseError = error
            urlData = nil
        }
        
        if ( urlData != nil ) {
            let res = response as! HTTPURLResponse!;
            
            var responseData:NSString  = NSString(data:urlData! as Data, encoding:String.Encoding.utf8.rawValue)!
            
           print(responseData)
            
            if ((res?.statusCode)! >= 200 && (res?.statusCode)! < 300)
            {
                let json = JSON(data: urlData! as Data)
                
                totalValoraciones = json.count
                
                if(json.count>0){
                    for index in 0...(json.count-1)
                    {
                        //guardamos cada opinión en arrays, cada una para un parámetro
                        usuarios.append((json[index]["usuario"].stringValue as NSString) as String)
                        valoraciones.append((json[index]["opinion"].stringValue as NSString) as String)
                        puntuaciones.append((json[index]["nota"].stringValue as NSString) as String)
                        fechas.append((json[index]["fecha"].stringValue as NSString) as String)

                    }
                }
            }
            else
            {
                SCLAlertView().showError("Error", subTitle:"La connexión falló", closeButtonTitle:"Cerrar")
                
            }
        }
        else
        {
            SCLAlertView().showError("Error", subTitle:"La connexión falló2", closeButtonTitle:"Cerrar")
            
        }
    }

    
    
    override func tableView(_ tableView: UITableView?, numberOfRowsInSection section: Int) -> Int
    {
       return self.usuarios.count;
    }
    
     //Rellenamos cada fila de la tabla con una opinión. cada elemento de la fila tiene un TAG que lo diferencia
    override func tableView(_ tableView: UITableView, cellForRowAt indexPath: IndexPath) -> UITableViewCell {
        let cell = tableView.dequeueReusableCell(withIdentifier: "valoracionesCell", for: indexPath)

        if let puntuacionLabel = cell.viewWithTag(100) as? UILabel
        {
            puntuacionLabel.text = self.puntuaciones[indexPath.row]
        }
        
        if let valoracionLabel = cell.viewWithTag(102) as? UILabel
        {
            valoracionLabel.text = self.valoraciones[indexPath.row]
        }
        
        if let usuarioLabel = cell.viewWithTag(101) as? UILabel
        {
            usuarioLabel.text = self.usuarios[indexPath.row]
        }
        
        if let fechaLabel = cell.viewWithTag(104) as? UILabel
        {
            fechaLabel.text = self.fechas[indexPath.row]
        }


        return cell
    }
    
     //Ponemos un título a la tabla
    override func tableView(_ tableView: UITableView, titleForHeaderInSection section: Int) -> String? {
        return "\(totalValoraciones) valoraciones encontradas"
    }
    
    override  func tableView(_ tableView: UITableView, didSelectRowAt indexPath: IndexPath){
          let index = tableView.indexPathForSelectedRow!
          let observacion = self.valoraciones[index.row]
        
         SCLAlertView().showInfo("Observación", subTitle:observacion, closeButtonTitle:"Cerrar")

        
    }
    
    override func didReceiveMemoryWarning()
    {
        super.didReceiveMemoryWarning()
    }
    
    //Función que se ejecuta al cargar la pantalla la primera vez
    override func viewDidLoad()
    {
        super.viewDidLoad()
        self.title = "Valoraciones"
        obtenerDatos()
    }
    
    
}
